# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ConfigurationSetDashboardOptions',
    'ConfigurationSetDeliveryOptions',
    'ConfigurationSetEventDestinationCloudWatchDestination',
    'ConfigurationSetEventDestinationDimensionConfiguration',
    'ConfigurationSetEventDestinationEventBridgeDestination',
    'ConfigurationSetEventDestinationEventDestination',
    'ConfigurationSetEventDestinationKinesisFirehoseDestination',
    'ConfigurationSetEventDestinationSnsDestination',
    'ConfigurationSetGuardianOptions',
    'ConfigurationSetReputationOptions',
    'ConfigurationSetSendingOptions',
    'ConfigurationSetSuppressionOptions',
    'ConfigurationSetTrackingOptions',
    'ConfigurationSetVdmOptions',
    'ContactListTopic',
    'EmailIdentityConfigurationSetAttributes',
    'EmailIdentityDkimAttributes',
    'EmailIdentityDkimSigningAttributes',
    'EmailIdentityFeedbackAttributes',
    'EmailIdentityMailFromAttributes',
    'MailManagerArchiveArchiveRetentionProperties',
    'MailManagerIngressPointIngressPointConfiguration0Properties',
    'MailManagerIngressPointIngressPointConfiguration1Properties',
    'MailManagerRelayNoAuthentication',
    'MailManagerRelayRelayAuthentication0Properties',
    'MailManagerRelayRelayAuthentication1Properties',
    'MailManagerRuleSetAddHeaderAction',
    'MailManagerRuleSetAnalysis',
    'MailManagerRuleSetArchiveAction',
    'MailManagerRuleSetDeliverToMailboxAction',
    'MailManagerRuleSetDropAction',
    'MailManagerRuleSetRelayAction',
    'MailManagerRuleSetReplaceRecipientAction',
    'MailManagerRuleSetRule',
    'MailManagerRuleSetRuleAction0Properties',
    'MailManagerRuleSetRuleAction1Properties',
    'MailManagerRuleSetRuleAction2Properties',
    'MailManagerRuleSetRuleAction3Properties',
    'MailManagerRuleSetRuleAction4Properties',
    'MailManagerRuleSetRuleAction5Properties',
    'MailManagerRuleSetRuleAction6Properties',
    'MailManagerRuleSetRuleAction7Properties',
    'MailManagerRuleSetRuleBooleanExpression',
    'MailManagerRuleSetRuleBooleanToEvaluateProperties',
    'MailManagerRuleSetRuleCondition0Properties',
    'MailManagerRuleSetRuleCondition1Properties',
    'MailManagerRuleSetRuleCondition2Properties',
    'MailManagerRuleSetRuleCondition3Properties',
    'MailManagerRuleSetRuleCondition4Properties',
    'MailManagerRuleSetRuleCondition5Properties',
    'MailManagerRuleSetRuleDmarcExpression',
    'MailManagerRuleSetRuleIpExpression',
    'MailManagerRuleSetRuleIpToEvaluateProperties',
    'MailManagerRuleSetRuleNumberExpression',
    'MailManagerRuleSetRuleNumberToEvaluateProperties',
    'MailManagerRuleSetRuleStringExpression',
    'MailManagerRuleSetRuleStringToEvaluateProperties',
    'MailManagerRuleSetRuleVerdictExpression',
    'MailManagerRuleSetRuleVerdictToEvaluate0Properties',
    'MailManagerRuleSetRuleVerdictToEvaluate1Properties',
    'MailManagerRuleSetS3Action',
    'MailManagerRuleSetSendAction',
    'MailManagerTrafficPolicyIngressAnalysis',
    'MailManagerTrafficPolicyIngressBooleanExpression',
    'MailManagerTrafficPolicyIngressBooleanToEvaluateProperties',
    'MailManagerTrafficPolicyIngressIpToEvaluateProperties',
    'MailManagerTrafficPolicyIngressIpv4Expression',
    'MailManagerTrafficPolicyIngressStringExpression',
    'MailManagerTrafficPolicyIngressStringToEvaluateProperties',
    'MailManagerTrafficPolicyIngressTlsProtocolExpression',
    'MailManagerTrafficPolicyIngressTlsProtocolToEvaluateProperties',
    'MailManagerTrafficPolicyPolicyCondition0Properties',
    'MailManagerTrafficPolicyPolicyCondition1Properties',
    'MailManagerTrafficPolicyPolicyCondition2Properties',
    'MailManagerTrafficPolicyPolicyCondition3Properties',
    'MailManagerTrafficPolicyPolicyStatement',
    'Template',
    'VdmAttributesDashboardAttributes',
    'VdmAttributesGuardianAttributes',
]

@pulumi.output_type
class ConfigurationSetDashboardOptions(dict):
    """
    Preferences regarding the Dashboard feature.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "engagementMetrics":
            suggest = "engagement_metrics"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetDashboardOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetDashboardOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetDashboardOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 engagement_metrics: str):
        """
        Preferences regarding the Dashboard feature.
        :param str engagement_metrics: Whether emails sent with this configuration set have engagement tracking enabled.
        """
        pulumi.set(__self__, "engagement_metrics", engagement_metrics)

    @property
    @pulumi.getter(name="engagementMetrics")
    def engagement_metrics(self) -> str:
        """
        Whether emails sent with this configuration set have engagement tracking enabled.
        """
        return pulumi.get(self, "engagement_metrics")


@pulumi.output_type
class ConfigurationSetDeliveryOptions(dict):
    """
    An object that defines the dedicated IP pool that is used to send emails that you send using the configuration set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sendingPoolName":
            suggest = "sending_pool_name"
        elif key == "tlsPolicy":
            suggest = "tls_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetDeliveryOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetDeliveryOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetDeliveryOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 sending_pool_name: Optional[str] = None,
                 tls_policy: Optional[str] = None):
        """
        An object that defines the dedicated IP pool that is used to send emails that you send using the configuration set.
        :param str sending_pool_name: The name of the dedicated IP pool to associate with the configuration set.
        :param str tls_policy: Specifies whether messages that use the configuration set are required to use Transport Layer Security (TLS). If the value is Require , messages are only delivered if a TLS connection can be established. If the value is Optional , messages can be delivered in plain text if a TLS connection can't be established.
        """
        if sending_pool_name is not None:
            pulumi.set(__self__, "sending_pool_name", sending_pool_name)
        if tls_policy is not None:
            pulumi.set(__self__, "tls_policy", tls_policy)

    @property
    @pulumi.getter(name="sendingPoolName")
    def sending_pool_name(self) -> Optional[str]:
        """
        The name of the dedicated IP pool to associate with the configuration set.
        """
        return pulumi.get(self, "sending_pool_name")

    @property
    @pulumi.getter(name="tlsPolicy")
    def tls_policy(self) -> Optional[str]:
        """
        Specifies whether messages that use the configuration set are required to use Transport Layer Security (TLS). If the value is Require , messages are only delivered if a TLS connection can be established. If the value is Optional , messages can be delivered in plain text if a TLS connection can't be established.
        """
        return pulumi.get(self, "tls_policy")


@pulumi.output_type
class ConfigurationSetEventDestinationCloudWatchDestination(dict):
    """
    An object that contains the names, default values, and sources of the dimensions associated with an Amazon CloudWatch event destination.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dimensionConfigurations":
            suggest = "dimension_configurations"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationCloudWatchDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationCloudWatchDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationCloudWatchDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dimension_configurations: Optional[Sequence['outputs.ConfigurationSetEventDestinationDimensionConfiguration']] = None):
        """
        An object that contains the names, default values, and sources of the dimensions associated with an Amazon CloudWatch event destination.
        :param Sequence['ConfigurationSetEventDestinationDimensionConfiguration'] dimension_configurations: A list of dimensions upon which to categorize your emails when you publish email sending events to Amazon CloudWatch.
        """
        if dimension_configurations is not None:
            pulumi.set(__self__, "dimension_configurations", dimension_configurations)

    @property
    @pulumi.getter(name="dimensionConfigurations")
    def dimension_configurations(self) -> Optional[Sequence['outputs.ConfigurationSetEventDestinationDimensionConfiguration']]:
        """
        A list of dimensions upon which to categorize your emails when you publish email sending events to Amazon CloudWatch.
        """
        return pulumi.get(self, "dimension_configurations")


@pulumi.output_type
class ConfigurationSetEventDestinationDimensionConfiguration(dict):
    """
    A list of dimensions upon which to categorize your emails when you publish email sending events to Amazon CloudWatch.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "defaultDimensionValue":
            suggest = "default_dimension_value"
        elif key == "dimensionName":
            suggest = "dimension_name"
        elif key == "dimensionValueSource":
            suggest = "dimension_value_source"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationDimensionConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationDimensionConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationDimensionConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 default_dimension_value: str,
                 dimension_name: str,
                 dimension_value_source: str):
        """
        A list of dimensions upon which to categorize your emails when you publish email sending events to Amazon CloudWatch.
        :param str default_dimension_value: The default value of the dimension that is published to Amazon CloudWatch if you do not provide the value of the dimension when you send an email.
        :param str dimension_name: The name of an Amazon CloudWatch dimension associated with an email sending metric.
        :param str dimension_value_source: The place where Amazon SES finds the value of a dimension to publish to Amazon CloudWatch. To use the message tags that you specify using an X-SES-MESSAGE-TAGS header or a parameter to the SendEmail/SendRawEmail API, specify messageTag. To use your own email headers, specify emailHeader. To put a custom tag on any link included in your email, specify linkTag.
        """
        pulumi.set(__self__, "default_dimension_value", default_dimension_value)
        pulumi.set(__self__, "dimension_name", dimension_name)
        pulumi.set(__self__, "dimension_value_source", dimension_value_source)

    @property
    @pulumi.getter(name="defaultDimensionValue")
    def default_dimension_value(self) -> str:
        """
        The default value of the dimension that is published to Amazon CloudWatch if you do not provide the value of the dimension when you send an email.
        """
        return pulumi.get(self, "default_dimension_value")

    @property
    @pulumi.getter(name="dimensionName")
    def dimension_name(self) -> str:
        """
        The name of an Amazon CloudWatch dimension associated with an email sending metric.
        """
        return pulumi.get(self, "dimension_name")

    @property
    @pulumi.getter(name="dimensionValueSource")
    def dimension_value_source(self) -> str:
        """
        The place where Amazon SES finds the value of a dimension to publish to Amazon CloudWatch. To use the message tags that you specify using an X-SES-MESSAGE-TAGS header or a parameter to the SendEmail/SendRawEmail API, specify messageTag. To use your own email headers, specify emailHeader. To put a custom tag on any link included in your email, specify linkTag.
        """
        return pulumi.get(self, "dimension_value_source")


@pulumi.output_type
class ConfigurationSetEventDestinationEventBridgeDestination(dict):
    """
    An object that contains Event bus ARN associated with the event bridge destination.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "eventBusArn":
            suggest = "event_bus_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationEventBridgeDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationEventBridgeDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationEventBridgeDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 event_bus_arn: str):
        """
        An object that contains Event bus ARN associated with the event bridge destination.
        :param str event_bus_arn: The Amazon Resource Name (ARN) of the Amazon EventBridge bus to publish email events to. Only the default bus is supported.
        """
        pulumi.set(__self__, "event_bus_arn", event_bus_arn)

    @property
    @pulumi.getter(name="eventBusArn")
    def event_bus_arn(self) -> str:
        """
        The Amazon Resource Name (ARN) of the Amazon EventBridge bus to publish email events to. Only the default bus is supported.
        """
        return pulumi.get(self, "event_bus_arn")


@pulumi.output_type
class ConfigurationSetEventDestinationEventDestination(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "matchingEventTypes":
            suggest = "matching_event_types"
        elif key == "cloudWatchDestination":
            suggest = "cloud_watch_destination"
        elif key == "eventBridgeDestination":
            suggest = "event_bridge_destination"
        elif key == "kinesisFirehoseDestination":
            suggest = "kinesis_firehose_destination"
        elif key == "snsDestination":
            suggest = "sns_destination"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationEventDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationEventDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationEventDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 matching_event_types: Sequence[str],
                 cloud_watch_destination: Optional['outputs.ConfigurationSetEventDestinationCloudWatchDestination'] = None,
                 enabled: Optional[bool] = None,
                 event_bridge_destination: Optional['outputs.ConfigurationSetEventDestinationEventBridgeDestination'] = None,
                 kinesis_firehose_destination: Optional['outputs.ConfigurationSetEventDestinationKinesisFirehoseDestination'] = None,
                 name: Optional[str] = None,
                 sns_destination: Optional['outputs.ConfigurationSetEventDestinationSnsDestination'] = None):
        """
        :param Sequence[str] matching_event_types: The type of email sending events, send, reject, bounce, complaint, delivery, open, click, renderingFailure, deliveryDelay, and subscription.
        :param 'ConfigurationSetEventDestinationCloudWatchDestination' cloud_watch_destination: An object that contains the names, default values, and sources of the dimensions associated with an Amazon CloudWatch event destination.
        :param bool enabled: Sets whether Amazon SES publishes events to this destination when you send an email with the associated configuration set. Set to true to enable publishing to this destination; set to false to prevent publishing to this destination. The default value is false.   
        :param 'ConfigurationSetEventDestinationEventBridgeDestination' event_bridge_destination: An object that contains Event bus ARN associated with the event bridge destination.
        :param 'ConfigurationSetEventDestinationKinesisFirehoseDestination' kinesis_firehose_destination: An object that contains the delivery stream ARN and the IAM role ARN associated with an Amazon Kinesis Firehose event destination.
        :param str name: The name of the event destination set.
        :param 'ConfigurationSetEventDestinationSnsDestination' sns_destination: An object that contains SNS topic ARN associated event destination.
        """
        pulumi.set(__self__, "matching_event_types", matching_event_types)
        if cloud_watch_destination is not None:
            pulumi.set(__self__, "cloud_watch_destination", cloud_watch_destination)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if event_bridge_destination is not None:
            pulumi.set(__self__, "event_bridge_destination", event_bridge_destination)
        if kinesis_firehose_destination is not None:
            pulumi.set(__self__, "kinesis_firehose_destination", kinesis_firehose_destination)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if sns_destination is not None:
            pulumi.set(__self__, "sns_destination", sns_destination)

    @property
    @pulumi.getter(name="matchingEventTypes")
    def matching_event_types(self) -> Sequence[str]:
        """
        The type of email sending events, send, reject, bounce, complaint, delivery, open, click, renderingFailure, deliveryDelay, and subscription.
        """
        return pulumi.get(self, "matching_event_types")

    @property
    @pulumi.getter(name="cloudWatchDestination")
    def cloud_watch_destination(self) -> Optional['outputs.ConfigurationSetEventDestinationCloudWatchDestination']:
        """
        An object that contains the names, default values, and sources of the dimensions associated with an Amazon CloudWatch event destination.
        """
        return pulumi.get(self, "cloud_watch_destination")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Sets whether Amazon SES publishes events to this destination when you send an email with the associated configuration set. Set to true to enable publishing to this destination; set to false to prevent publishing to this destination. The default value is false.   
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="eventBridgeDestination")
    def event_bridge_destination(self) -> Optional['outputs.ConfigurationSetEventDestinationEventBridgeDestination']:
        """
        An object that contains Event bus ARN associated with the event bridge destination.
        """
        return pulumi.get(self, "event_bridge_destination")

    @property
    @pulumi.getter(name="kinesisFirehoseDestination")
    def kinesis_firehose_destination(self) -> Optional['outputs.ConfigurationSetEventDestinationKinesisFirehoseDestination']:
        """
        An object that contains the delivery stream ARN and the IAM role ARN associated with an Amazon Kinesis Firehose event destination.
        """
        return pulumi.get(self, "kinesis_firehose_destination")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the event destination set.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="snsDestination")
    def sns_destination(self) -> Optional['outputs.ConfigurationSetEventDestinationSnsDestination']:
        """
        An object that contains SNS topic ARN associated event destination.
        """
        return pulumi.get(self, "sns_destination")


@pulumi.output_type
class ConfigurationSetEventDestinationKinesisFirehoseDestination(dict):
    """
    An object that contains the delivery stream ARN and the IAM role ARN associated with an Amazon Kinesis Firehose event destination.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "deliveryStreamArn":
            suggest = "delivery_stream_arn"
        elif key == "iamRoleArn":
            suggest = "iam_role_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationKinesisFirehoseDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationKinesisFirehoseDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationKinesisFirehoseDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 delivery_stream_arn: str,
                 iam_role_arn: str):
        """
        An object that contains the delivery stream ARN and the IAM role ARN associated with an Amazon Kinesis Firehose event destination.
        :param str delivery_stream_arn: The ARN of the Amazon Kinesis Firehose stream that email sending events should be published to.
        :param str iam_role_arn: The ARN of the IAM role under which Amazon SES publishes email sending events to the Amazon Kinesis Firehose stream.
        """
        pulumi.set(__self__, "delivery_stream_arn", delivery_stream_arn)
        pulumi.set(__self__, "iam_role_arn", iam_role_arn)

    @property
    @pulumi.getter(name="deliveryStreamArn")
    def delivery_stream_arn(self) -> str:
        """
        The ARN of the Amazon Kinesis Firehose stream that email sending events should be published to.
        """
        return pulumi.get(self, "delivery_stream_arn")

    @property
    @pulumi.getter(name="iamRoleArn")
    def iam_role_arn(self) -> str:
        """
        The ARN of the IAM role under which Amazon SES publishes email sending events to the Amazon Kinesis Firehose stream.
        """
        return pulumi.get(self, "iam_role_arn")


@pulumi.output_type
class ConfigurationSetEventDestinationSnsDestination(dict):
    """
    An object that contains SNS topic ARN associated event destination.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "topicArn":
            suggest = "topic_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetEventDestinationSnsDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetEventDestinationSnsDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetEventDestinationSnsDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 topic_arn: str):
        """
        An object that contains SNS topic ARN associated event destination.
        :param str topic_arn: The ARN of the Amazon SNS topic for email sending events. You can find the ARN of a topic by using the [ListTopics](https://docs.aws.amazon.com/sns/latest/api/API_ListTopics.html) Amazon SNS operation.
               
               For more information about Amazon SNS topics, see the [Amazon SNS Developer Guide](https://docs.aws.amazon.com/sns/latest/dg/CreateTopic.html) .
        """
        pulumi.set(__self__, "topic_arn", topic_arn)

    @property
    @pulumi.getter(name="topicArn")
    def topic_arn(self) -> str:
        """
        The ARN of the Amazon SNS topic for email sending events. You can find the ARN of a topic by using the [ListTopics](https://docs.aws.amazon.com/sns/latest/api/API_ListTopics.html) Amazon SNS operation.

        For more information about Amazon SNS topics, see the [Amazon SNS Developer Guide](https://docs.aws.amazon.com/sns/latest/dg/CreateTopic.html) .
        """
        return pulumi.get(self, "topic_arn")


@pulumi.output_type
class ConfigurationSetGuardianOptions(dict):
    """
    Preferences regarding the Guardian feature.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "optimizedSharedDelivery":
            suggest = "optimized_shared_delivery"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetGuardianOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetGuardianOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetGuardianOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 optimized_shared_delivery: str):
        """
        Preferences regarding the Guardian feature.
        :param str optimized_shared_delivery: Whether emails sent with this configuration set have optimized delivery algorithm enabled.
        """
        pulumi.set(__self__, "optimized_shared_delivery", optimized_shared_delivery)

    @property
    @pulumi.getter(name="optimizedSharedDelivery")
    def optimized_shared_delivery(self) -> str:
        """
        Whether emails sent with this configuration set have optimized delivery algorithm enabled.
        """
        return pulumi.get(self, "optimized_shared_delivery")


@pulumi.output_type
class ConfigurationSetReputationOptions(dict):
    """
    An object that defines whether or not Amazon SES collects reputation metrics for the emails that you send that use the configuration set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "reputationMetricsEnabled":
            suggest = "reputation_metrics_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetReputationOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetReputationOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetReputationOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 reputation_metrics_enabled: Optional[bool] = None):
        """
        An object that defines whether or not Amazon SES collects reputation metrics for the emails that you send that use the configuration set.
        :param bool reputation_metrics_enabled: If true , tracking of reputation metrics is enabled for the configuration set. If false , tracking of reputation metrics is disabled for the configuration set.
        """
        if reputation_metrics_enabled is not None:
            pulumi.set(__self__, "reputation_metrics_enabled", reputation_metrics_enabled)

    @property
    @pulumi.getter(name="reputationMetricsEnabled")
    def reputation_metrics_enabled(self) -> Optional[bool]:
        """
        If true , tracking of reputation metrics is enabled for the configuration set. If false , tracking of reputation metrics is disabled for the configuration set.
        """
        return pulumi.get(self, "reputation_metrics_enabled")


@pulumi.output_type
class ConfigurationSetSendingOptions(dict):
    """
    An object that defines whether or not Amazon SES can send email that you send using the configuration set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sendingEnabled":
            suggest = "sending_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetSendingOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetSendingOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetSendingOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 sending_enabled: Optional[bool] = None):
        """
        An object that defines whether or not Amazon SES can send email that you send using the configuration set.
        :param bool sending_enabled: If `true` , email sending is enabled for the configuration set. If `false` , email sending is disabled for the configuration set.
        """
        if sending_enabled is not None:
            pulumi.set(__self__, "sending_enabled", sending_enabled)

    @property
    @pulumi.getter(name="sendingEnabled")
    def sending_enabled(self) -> Optional[bool]:
        """
        If `true` , email sending is enabled for the configuration set. If `false` , email sending is disabled for the configuration set.
        """
        return pulumi.get(self, "sending_enabled")


@pulumi.output_type
class ConfigurationSetSuppressionOptions(dict):
    """
    An object that contains information about the suppression list preferences for your account.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "suppressedReasons":
            suggest = "suppressed_reasons"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetSuppressionOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetSuppressionOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetSuppressionOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 suppressed_reasons: Optional[Sequence[str]] = None):
        """
        An object that contains information about the suppression list preferences for your account.
        :param Sequence[str] suppressed_reasons: A list that contains the reasons that email addresses are automatically added to the suppression list for your account.
        """
        if suppressed_reasons is not None:
            pulumi.set(__self__, "suppressed_reasons", suppressed_reasons)

    @property
    @pulumi.getter(name="suppressedReasons")
    def suppressed_reasons(self) -> Optional[Sequence[str]]:
        """
        A list that contains the reasons that email addresses are automatically added to the suppression list for your account.
        """
        return pulumi.get(self, "suppressed_reasons")


@pulumi.output_type
class ConfigurationSetTrackingOptions(dict):
    """
    An object that defines the open and click tracking options for emails that you send using the configuration set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "customRedirectDomain":
            suggest = "custom_redirect_domain"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetTrackingOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetTrackingOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetTrackingOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 custom_redirect_domain: Optional[str] = None):
        """
        An object that defines the open and click tracking options for emails that you send using the configuration set.
        :param str custom_redirect_domain: The domain to use for tracking open and click events.
        """
        if custom_redirect_domain is not None:
            pulumi.set(__self__, "custom_redirect_domain", custom_redirect_domain)

    @property
    @pulumi.getter(name="customRedirectDomain")
    def custom_redirect_domain(self) -> Optional[str]:
        """
        The domain to use for tracking open and click events.
        """
        return pulumi.get(self, "custom_redirect_domain")


@pulumi.output_type
class ConfigurationSetVdmOptions(dict):
    """
    An object that contains Virtual Deliverability Manager (VDM) settings for this configuration set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dashboardOptions":
            suggest = "dashboard_options"
        elif key == "guardianOptions":
            suggest = "guardian_options"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationSetVdmOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationSetVdmOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationSetVdmOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dashboard_options: Optional['outputs.ConfigurationSetDashboardOptions'] = None,
                 guardian_options: Optional['outputs.ConfigurationSetGuardianOptions'] = None):
        """
        An object that contains Virtual Deliverability Manager (VDM) settings for this configuration set.
        :param 'ConfigurationSetDashboardOptions' dashboard_options: Specifies additional settings for your VDM configuration as applicable to the Dashboard.
        :param 'ConfigurationSetGuardianOptions' guardian_options: Specifies additional settings for your VDM configuration as applicable to the Guardian.
        """
        if dashboard_options is not None:
            pulumi.set(__self__, "dashboard_options", dashboard_options)
        if guardian_options is not None:
            pulumi.set(__self__, "guardian_options", guardian_options)

    @property
    @pulumi.getter(name="dashboardOptions")
    def dashboard_options(self) -> Optional['outputs.ConfigurationSetDashboardOptions']:
        """
        Specifies additional settings for your VDM configuration as applicable to the Dashboard.
        """
        return pulumi.get(self, "dashboard_options")

    @property
    @pulumi.getter(name="guardianOptions")
    def guardian_options(self) -> Optional['outputs.ConfigurationSetGuardianOptions']:
        """
        Specifies additional settings for your VDM configuration as applicable to the Guardian.
        """
        return pulumi.get(self, "guardian_options")


@pulumi.output_type
class ContactListTopic(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "defaultSubscriptionStatus":
            suggest = "default_subscription_status"
        elif key == "displayName":
            suggest = "display_name"
        elif key == "topicName":
            suggest = "topic_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ContactListTopic. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ContactListTopic.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ContactListTopic.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 default_subscription_status: str,
                 display_name: str,
                 topic_name: str,
                 description: Optional[str] = None):
        """
        :param str default_subscription_status: The default subscription status to be applied to a contact if the contact has not noted their preference for subscribing to a topic.
        :param str display_name: The display name of the topic.
        :param str topic_name: The name of the topic.
        :param str description: The description of the topic.
        """
        pulumi.set(__self__, "default_subscription_status", default_subscription_status)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "topic_name", topic_name)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter(name="defaultSubscriptionStatus")
    def default_subscription_status(self) -> str:
        """
        The default subscription status to be applied to a contact if the contact has not noted their preference for subscribing to a topic.
        """
        return pulumi.get(self, "default_subscription_status")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        The display name of the topic.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> str:
        """
        The name of the topic.
        """
        return pulumi.get(self, "topic_name")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        The description of the topic.
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class EmailIdentityConfigurationSetAttributes(dict):
    """
    Used to associate a configuration set with an email identity.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "configurationSetName":
            suggest = "configuration_set_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EmailIdentityConfigurationSetAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EmailIdentityConfigurationSetAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EmailIdentityConfigurationSetAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 configuration_set_name: Optional[str] = None):
        """
        Used to associate a configuration set with an email identity.
        :param str configuration_set_name: The configuration set to use by default when sending from this identity. Note that any configuration set defined in the email sending request takes precedence.
        """
        if configuration_set_name is not None:
            pulumi.set(__self__, "configuration_set_name", configuration_set_name)

    @property
    @pulumi.getter(name="configurationSetName")
    def configuration_set_name(self) -> Optional[str]:
        """
        The configuration set to use by default when sending from this identity. Note that any configuration set defined in the email sending request takes precedence.
        """
        return pulumi.get(self, "configuration_set_name")


@pulumi.output_type
class EmailIdentityDkimAttributes(dict):
    """
    Used to enable or disable DKIM authentication for an email identity.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "signingEnabled":
            suggest = "signing_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EmailIdentityDkimAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EmailIdentityDkimAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EmailIdentityDkimAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 signing_enabled: Optional[bool] = None):
        """
        Used to enable or disable DKIM authentication for an email identity.
        :param bool signing_enabled: Sets the DKIM signing configuration for the identity. When you set this value true, then the messages that are sent from the identity are signed using DKIM. If you set this value to false, your messages are sent without DKIM signing.
        """
        if signing_enabled is not None:
            pulumi.set(__self__, "signing_enabled", signing_enabled)

    @property
    @pulumi.getter(name="signingEnabled")
    def signing_enabled(self) -> Optional[bool]:
        """
        Sets the DKIM signing configuration for the identity. When you set this value true, then the messages that are sent from the identity are signed using DKIM. If you set this value to false, your messages are sent without DKIM signing.
        """
        return pulumi.get(self, "signing_enabled")


@pulumi.output_type
class EmailIdentityDkimSigningAttributes(dict):
    """
    If your request includes this object, Amazon SES configures the identity to use Bring Your Own DKIM (BYODKIM) for DKIM authentication purposes, or, configures the key length to be used for Easy DKIM.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "domainSigningPrivateKey":
            suggest = "domain_signing_private_key"
        elif key == "domainSigningSelector":
            suggest = "domain_signing_selector"
        elif key == "nextSigningKeyLength":
            suggest = "next_signing_key_length"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EmailIdentityDkimSigningAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EmailIdentityDkimSigningAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EmailIdentityDkimSigningAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 domain_signing_private_key: Optional[str] = None,
                 domain_signing_selector: Optional[str] = None,
                 next_signing_key_length: Optional[str] = None):
        """
        If your request includes this object, Amazon SES configures the identity to use Bring Your Own DKIM (BYODKIM) for DKIM authentication purposes, or, configures the key length to be used for Easy DKIM.
        :param str domain_signing_private_key: [Bring Your Own DKIM] A private key that's used to generate a DKIM signature. The private key must use 1024 or 2048-bit RSA encryption, and must be encoded using base64 encoding.
        :param str domain_signing_selector: [Bring Your Own DKIM] A string that's used to identify a public key in the DNS configuration for a domain.
        :param str next_signing_key_length: [Easy DKIM] The key length of the future DKIM key pair to be generated. This can be changed at most once per day.
        """
        if domain_signing_private_key is not None:
            pulumi.set(__self__, "domain_signing_private_key", domain_signing_private_key)
        if domain_signing_selector is not None:
            pulumi.set(__self__, "domain_signing_selector", domain_signing_selector)
        if next_signing_key_length is not None:
            pulumi.set(__self__, "next_signing_key_length", next_signing_key_length)

    @property
    @pulumi.getter(name="domainSigningPrivateKey")
    def domain_signing_private_key(self) -> Optional[str]:
        """
        [Bring Your Own DKIM] A private key that's used to generate a DKIM signature. The private key must use 1024 or 2048-bit RSA encryption, and must be encoded using base64 encoding.
        """
        return pulumi.get(self, "domain_signing_private_key")

    @property
    @pulumi.getter(name="domainSigningSelector")
    def domain_signing_selector(self) -> Optional[str]:
        """
        [Bring Your Own DKIM] A string that's used to identify a public key in the DNS configuration for a domain.
        """
        return pulumi.get(self, "domain_signing_selector")

    @property
    @pulumi.getter(name="nextSigningKeyLength")
    def next_signing_key_length(self) -> Optional[str]:
        """
        [Easy DKIM] The key length of the future DKIM key pair to be generated. This can be changed at most once per day.
        """
        return pulumi.get(self, "next_signing_key_length")


@pulumi.output_type
class EmailIdentityFeedbackAttributes(dict):
    """
    Used to enable or disable feedback forwarding for an identity.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "emailForwardingEnabled":
            suggest = "email_forwarding_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EmailIdentityFeedbackAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EmailIdentityFeedbackAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EmailIdentityFeedbackAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 email_forwarding_enabled: Optional[bool] = None):
        """
        Used to enable or disable feedback forwarding for an identity.
        :param bool email_forwarding_enabled: If the value is true, you receive email notifications when bounce or complaint events occur
        """
        if email_forwarding_enabled is not None:
            pulumi.set(__self__, "email_forwarding_enabled", email_forwarding_enabled)

    @property
    @pulumi.getter(name="emailForwardingEnabled")
    def email_forwarding_enabled(self) -> Optional[bool]:
        """
        If the value is true, you receive email notifications when bounce or complaint events occur
        """
        return pulumi.get(self, "email_forwarding_enabled")


@pulumi.output_type
class EmailIdentityMailFromAttributes(dict):
    """
    Used to enable or disable the custom Mail-From domain configuration for an email identity.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "behaviorOnMxFailure":
            suggest = "behavior_on_mx_failure"
        elif key == "mailFromDomain":
            suggest = "mail_from_domain"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EmailIdentityMailFromAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EmailIdentityMailFromAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EmailIdentityMailFromAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 behavior_on_mx_failure: Optional[str] = None,
                 mail_from_domain: Optional[str] = None):
        """
        Used to enable or disable the custom Mail-From domain configuration for an email identity.
        :param str behavior_on_mx_failure: The action to take if the required MX record isn't found when you send an email. When you set this value to UseDefaultValue , the mail is sent using amazonses.com as the MAIL FROM domain. When you set this value to RejectMessage , the Amazon SES API v2 returns a MailFromDomainNotVerified error, and doesn't attempt to deliver the email.
        :param str mail_from_domain: The custom MAIL FROM domain that you want the verified identity to use
        """
        if behavior_on_mx_failure is not None:
            pulumi.set(__self__, "behavior_on_mx_failure", behavior_on_mx_failure)
        if mail_from_domain is not None:
            pulumi.set(__self__, "mail_from_domain", mail_from_domain)

    @property
    @pulumi.getter(name="behaviorOnMxFailure")
    def behavior_on_mx_failure(self) -> Optional[str]:
        """
        The action to take if the required MX record isn't found when you send an email. When you set this value to UseDefaultValue , the mail is sent using amazonses.com as the MAIL FROM domain. When you set this value to RejectMessage , the Amazon SES API v2 returns a MailFromDomainNotVerified error, and doesn't attempt to deliver the email.
        """
        return pulumi.get(self, "behavior_on_mx_failure")

    @property
    @pulumi.getter(name="mailFromDomain")
    def mail_from_domain(self) -> Optional[str]:
        """
        The custom MAIL FROM domain that you want the verified identity to use
        """
        return pulumi.get(self, "mail_from_domain")


@pulumi.output_type
class MailManagerArchiveArchiveRetentionProperties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "retentionPeriod":
            suggest = "retention_period"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerArchiveArchiveRetentionProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerArchiveArchiveRetentionProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerArchiveArchiveRetentionProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 retention_period: 'MailManagerArchiveRetentionPeriod'):
        pulumi.set(__self__, "retention_period", retention_period)

    @property
    @pulumi.getter(name="retentionPeriod")
    def retention_period(self) -> 'MailManagerArchiveRetentionPeriod':
        return pulumi.get(self, "retention_period")


@pulumi.output_type
class MailManagerIngressPointIngressPointConfiguration0Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "smtpPassword":
            suggest = "smtp_password"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerIngressPointIngressPointConfiguration0Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerIngressPointIngressPointConfiguration0Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerIngressPointIngressPointConfiguration0Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 smtp_password: str):
        pulumi.set(__self__, "smtp_password", smtp_password)

    @property
    @pulumi.getter(name="smtpPassword")
    def smtp_password(self) -> str:
        return pulumi.get(self, "smtp_password")


@pulumi.output_type
class MailManagerIngressPointIngressPointConfiguration1Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "secretArn":
            suggest = "secret_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerIngressPointIngressPointConfiguration1Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerIngressPointIngressPointConfiguration1Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerIngressPointIngressPointConfiguration1Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 secret_arn: str):
        pulumi.set(__self__, "secret_arn", secret_arn)

    @property
    @pulumi.getter(name="secretArn")
    def secret_arn(self) -> str:
        return pulumi.get(self, "secret_arn")


@pulumi.output_type
class MailManagerRelayNoAuthentication(dict):
    def __init__(__self__):
        pass


@pulumi.output_type
class MailManagerRelayRelayAuthentication0Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "secretArn":
            suggest = "secret_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRelayRelayAuthentication0Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRelayRelayAuthentication0Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRelayRelayAuthentication0Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 secret_arn: str):
        pulumi.set(__self__, "secret_arn", secret_arn)

    @property
    @pulumi.getter(name="secretArn")
    def secret_arn(self) -> str:
        return pulumi.get(self, "secret_arn")


@pulumi.output_type
class MailManagerRelayRelayAuthentication1Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "noAuthentication":
            suggest = "no_authentication"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRelayRelayAuthentication1Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRelayRelayAuthentication1Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRelayRelayAuthentication1Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 no_authentication: 'outputs.MailManagerRelayNoAuthentication'):
        pulumi.set(__self__, "no_authentication", no_authentication)

    @property
    @pulumi.getter(name="noAuthentication")
    def no_authentication(self) -> 'outputs.MailManagerRelayNoAuthentication':
        return pulumi.get(self, "no_authentication")


@pulumi.output_type
class MailManagerRuleSetAddHeaderAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "headerName":
            suggest = "header_name"
        elif key == "headerValue":
            suggest = "header_value"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetAddHeaderAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetAddHeaderAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetAddHeaderAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 header_name: str,
                 header_value: str):
        pulumi.set(__self__, "header_name", header_name)
        pulumi.set(__self__, "header_value", header_value)

    @property
    @pulumi.getter(name="headerName")
    def header_name(self) -> str:
        return pulumi.get(self, "header_name")

    @property
    @pulumi.getter(name="headerValue")
    def header_value(self) -> str:
        return pulumi.get(self, "header_value")


@pulumi.output_type
class MailManagerRuleSetAnalysis(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resultField":
            suggest = "result_field"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetAnalysis. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetAnalysis.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetAnalysis.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 analyzer: str,
                 result_field: str):
        pulumi.set(__self__, "analyzer", analyzer)
        pulumi.set(__self__, "result_field", result_field)

    @property
    @pulumi.getter
    def analyzer(self) -> str:
        return pulumi.get(self, "analyzer")

    @property
    @pulumi.getter(name="resultField")
    def result_field(self) -> str:
        return pulumi.get(self, "result_field")


@pulumi.output_type
class MailManagerRuleSetArchiveAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "targetArchive":
            suggest = "target_archive"
        elif key == "actionFailurePolicy":
            suggest = "action_failure_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetArchiveAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetArchiveAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetArchiveAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 target_archive: str,
                 action_failure_policy: Optional['MailManagerRuleSetActionFailurePolicy'] = None):
        pulumi.set(__self__, "target_archive", target_archive)
        if action_failure_policy is not None:
            pulumi.set(__self__, "action_failure_policy", action_failure_policy)

    @property
    @pulumi.getter(name="targetArchive")
    def target_archive(self) -> str:
        return pulumi.get(self, "target_archive")

    @property
    @pulumi.getter(name="actionFailurePolicy")
    def action_failure_policy(self) -> Optional['MailManagerRuleSetActionFailurePolicy']:
        return pulumi.get(self, "action_failure_policy")


@pulumi.output_type
class MailManagerRuleSetDeliverToMailboxAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "mailboxArn":
            suggest = "mailbox_arn"
        elif key == "roleArn":
            suggest = "role_arn"
        elif key == "actionFailurePolicy":
            suggest = "action_failure_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetDeliverToMailboxAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetDeliverToMailboxAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetDeliverToMailboxAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 mailbox_arn: str,
                 role_arn: str,
                 action_failure_policy: Optional['MailManagerRuleSetActionFailurePolicy'] = None):
        pulumi.set(__self__, "mailbox_arn", mailbox_arn)
        pulumi.set(__self__, "role_arn", role_arn)
        if action_failure_policy is not None:
            pulumi.set(__self__, "action_failure_policy", action_failure_policy)

    @property
    @pulumi.getter(name="mailboxArn")
    def mailbox_arn(self) -> str:
        return pulumi.get(self, "mailbox_arn")

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="actionFailurePolicy")
    def action_failure_policy(self) -> Optional['MailManagerRuleSetActionFailurePolicy']:
        return pulumi.get(self, "action_failure_policy")


@pulumi.output_type
class MailManagerRuleSetDropAction(dict):
    def __init__(__self__):
        pass


@pulumi.output_type
class MailManagerRuleSetRelayAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "actionFailurePolicy":
            suggest = "action_failure_policy"
        elif key == "mailFrom":
            suggest = "mail_from"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRelayAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRelayAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRelayAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 relay: str,
                 action_failure_policy: Optional['MailManagerRuleSetActionFailurePolicy'] = None,
                 mail_from: Optional['MailManagerRuleSetMailFrom'] = None):
        pulumi.set(__self__, "relay", relay)
        if action_failure_policy is not None:
            pulumi.set(__self__, "action_failure_policy", action_failure_policy)
        if mail_from is not None:
            pulumi.set(__self__, "mail_from", mail_from)

    @property
    @pulumi.getter
    def relay(self) -> str:
        return pulumi.get(self, "relay")

    @property
    @pulumi.getter(name="actionFailurePolicy")
    def action_failure_policy(self) -> Optional['MailManagerRuleSetActionFailurePolicy']:
        return pulumi.get(self, "action_failure_policy")

    @property
    @pulumi.getter(name="mailFrom")
    def mail_from(self) -> Optional['MailManagerRuleSetMailFrom']:
        return pulumi.get(self, "mail_from")


@pulumi.output_type
class MailManagerRuleSetReplaceRecipientAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "replaceWith":
            suggest = "replace_with"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetReplaceRecipientAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetReplaceRecipientAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetReplaceRecipientAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 replace_with: Optional[Sequence[str]] = None):
        if replace_with is not None:
            pulumi.set(__self__, "replace_with", replace_with)

    @property
    @pulumi.getter(name="replaceWith")
    def replace_with(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "replace_with")


@pulumi.output_type
class MailManagerRuleSetRule(dict):
    def __init__(__self__, *,
                 actions: Sequence[Any],
                 conditions: Optional[Sequence[Any]] = None,
                 name: Optional[str] = None,
                 unless: Optional[Sequence[Any]] = None):
        """
        :param Sequence[Union['MailManagerRuleSetRuleAction0Properties', 'MailManagerRuleSetRuleAction1Properties', 'MailManagerRuleSetRuleAction2Properties', 'MailManagerRuleSetRuleAction3Properties', 'MailManagerRuleSetRuleAction4Properties', 'MailManagerRuleSetRuleAction5Properties', 'MailManagerRuleSetRuleAction6Properties', 'MailManagerRuleSetRuleAction7Properties']] actions: The list of actions to execute when the conditions match the incoming email, and none of the "unless conditions" match.
        :param Sequence[Union['MailManagerRuleSetRuleCondition0Properties', 'MailManagerRuleSetRuleCondition1Properties', 'MailManagerRuleSetRuleCondition2Properties', 'MailManagerRuleSetRuleCondition3Properties', 'MailManagerRuleSetRuleCondition4Properties', 'MailManagerRuleSetRuleCondition5Properties']] conditions: The conditions of this rule. All conditions must match the email for the actions to be executed. An empty list of conditions means that all emails match, but are still subject to any "unless conditions"
        :param str name: The user-friendly name of the rule.
        :param Sequence[Union['MailManagerRuleSetRuleCondition0Properties', 'MailManagerRuleSetRuleCondition1Properties', 'MailManagerRuleSetRuleCondition2Properties', 'MailManagerRuleSetRuleCondition3Properties', 'MailManagerRuleSetRuleCondition4Properties', 'MailManagerRuleSetRuleCondition5Properties']] unless: The "unless conditions" of this rule. None of the conditions can match the email for the actions to be executed. If any of these conditions do match the email, then the actions are not executed.
        """
        pulumi.set(__self__, "actions", actions)
        if conditions is not None:
            pulumi.set(__self__, "conditions", conditions)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if unless is not None:
            pulumi.set(__self__, "unless", unless)

    @property
    @pulumi.getter
    def actions(self) -> Sequence[Any]:
        """
        The list of actions to execute when the conditions match the incoming email, and none of the "unless conditions" match.
        """
        return pulumi.get(self, "actions")

    @property
    @pulumi.getter
    def conditions(self) -> Optional[Sequence[Any]]:
        """
        The conditions of this rule. All conditions must match the email for the actions to be executed. An empty list of conditions means that all emails match, but are still subject to any "unless conditions"
        """
        return pulumi.get(self, "conditions")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The user-friendly name of the rule.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def unless(self) -> Optional[Sequence[Any]]:
        """
        The "unless conditions" of this rule. None of the conditions can match the email for the actions to be executed. If any of these conditions do match the email, then the actions are not executed.
        """
        return pulumi.get(self, "unless")


@pulumi.output_type
class MailManagerRuleSetRuleAction0Properties(dict):
    def __init__(__self__, *,
                 drop: 'outputs.MailManagerRuleSetDropAction'):
        pulumi.set(__self__, "drop", drop)

    @property
    @pulumi.getter
    def drop(self) -> 'outputs.MailManagerRuleSetDropAction':
        return pulumi.get(self, "drop")


@pulumi.output_type
class MailManagerRuleSetRuleAction1Properties(dict):
    def __init__(__self__, *,
                 relay: 'outputs.MailManagerRuleSetRelayAction'):
        pulumi.set(__self__, "relay", relay)

    @property
    @pulumi.getter
    def relay(self) -> 'outputs.MailManagerRuleSetRelayAction':
        return pulumi.get(self, "relay")


@pulumi.output_type
class MailManagerRuleSetRuleAction2Properties(dict):
    def __init__(__self__, *,
                 archive: 'outputs.MailManagerRuleSetArchiveAction'):
        pulumi.set(__self__, "archive", archive)

    @property
    @pulumi.getter
    def archive(self) -> 'outputs.MailManagerRuleSetArchiveAction':
        return pulumi.get(self, "archive")


@pulumi.output_type
class MailManagerRuleSetRuleAction3Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "writeToS3":
            suggest = "write_to_s3"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleAction3Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleAction3Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleAction3Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 write_to_s3: 'outputs.MailManagerRuleSetS3Action'):
        pulumi.set(__self__, "write_to_s3", write_to_s3)

    @property
    @pulumi.getter(name="writeToS3")
    def write_to_s3(self) -> 'outputs.MailManagerRuleSetS3Action':
        return pulumi.get(self, "write_to_s3")


@pulumi.output_type
class MailManagerRuleSetRuleAction4Properties(dict):
    def __init__(__self__, *,
                 send: 'outputs.MailManagerRuleSetSendAction'):
        pulumi.set(__self__, "send", send)

    @property
    @pulumi.getter
    def send(self) -> 'outputs.MailManagerRuleSetSendAction':
        return pulumi.get(self, "send")


@pulumi.output_type
class MailManagerRuleSetRuleAction5Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addHeader":
            suggest = "add_header"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleAction5Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleAction5Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleAction5Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 add_header: 'outputs.MailManagerRuleSetAddHeaderAction'):
        pulumi.set(__self__, "add_header", add_header)

    @property
    @pulumi.getter(name="addHeader")
    def add_header(self) -> 'outputs.MailManagerRuleSetAddHeaderAction':
        return pulumi.get(self, "add_header")


@pulumi.output_type
class MailManagerRuleSetRuleAction6Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "replaceRecipient":
            suggest = "replace_recipient"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleAction6Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleAction6Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleAction6Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 replace_recipient: 'outputs.MailManagerRuleSetReplaceRecipientAction'):
        pulumi.set(__self__, "replace_recipient", replace_recipient)

    @property
    @pulumi.getter(name="replaceRecipient")
    def replace_recipient(self) -> 'outputs.MailManagerRuleSetReplaceRecipientAction':
        return pulumi.get(self, "replace_recipient")


@pulumi.output_type
class MailManagerRuleSetRuleAction7Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "deliverToMailbox":
            suggest = "deliver_to_mailbox"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleAction7Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleAction7Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleAction7Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 deliver_to_mailbox: 'outputs.MailManagerRuleSetDeliverToMailboxAction'):
        pulumi.set(__self__, "deliver_to_mailbox", deliver_to_mailbox)

    @property
    @pulumi.getter(name="deliverToMailbox")
    def deliver_to_mailbox(self) -> 'outputs.MailManagerRuleSetDeliverToMailboxAction':
        return pulumi.get(self, "deliver_to_mailbox")


@pulumi.output_type
class MailManagerRuleSetRuleBooleanExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerRuleSetRuleBooleanToEvaluateProperties',
                 operator: 'MailManagerRuleSetRuleBooleanOperator'):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerRuleSetRuleBooleanToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleBooleanOperator':
        return pulumi.get(self, "operator")


@pulumi.output_type
class MailManagerRuleSetRuleBooleanToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerRuleSetRuleBooleanEmailAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerRuleSetRuleBooleanEmailAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerRuleSetRuleCondition0Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "booleanExpression":
            suggest = "boolean_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition0Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition0Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition0Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 boolean_expression: 'outputs.MailManagerRuleSetRuleBooleanExpression'):
        pulumi.set(__self__, "boolean_expression", boolean_expression)

    @property
    @pulumi.getter(name="booleanExpression")
    def boolean_expression(self) -> 'outputs.MailManagerRuleSetRuleBooleanExpression':
        return pulumi.get(self, "boolean_expression")


@pulumi.output_type
class MailManagerRuleSetRuleCondition1Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "stringExpression":
            suggest = "string_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition1Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition1Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition1Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 string_expression: 'outputs.MailManagerRuleSetRuleStringExpression'):
        pulumi.set(__self__, "string_expression", string_expression)

    @property
    @pulumi.getter(name="stringExpression")
    def string_expression(self) -> 'outputs.MailManagerRuleSetRuleStringExpression':
        return pulumi.get(self, "string_expression")


@pulumi.output_type
class MailManagerRuleSetRuleCondition2Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "numberExpression":
            suggest = "number_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition2Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition2Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition2Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 number_expression: 'outputs.MailManagerRuleSetRuleNumberExpression'):
        pulumi.set(__self__, "number_expression", number_expression)

    @property
    @pulumi.getter(name="numberExpression")
    def number_expression(self) -> 'outputs.MailManagerRuleSetRuleNumberExpression':
        return pulumi.get(self, "number_expression")


@pulumi.output_type
class MailManagerRuleSetRuleCondition3Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipExpression":
            suggest = "ip_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition3Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition3Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition3Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_expression: 'outputs.MailManagerRuleSetRuleIpExpression'):
        pulumi.set(__self__, "ip_expression", ip_expression)

    @property
    @pulumi.getter(name="ipExpression")
    def ip_expression(self) -> 'outputs.MailManagerRuleSetRuleIpExpression':
        return pulumi.get(self, "ip_expression")


@pulumi.output_type
class MailManagerRuleSetRuleCondition4Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "verdictExpression":
            suggest = "verdict_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition4Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition4Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition4Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 verdict_expression: 'outputs.MailManagerRuleSetRuleVerdictExpression'):
        pulumi.set(__self__, "verdict_expression", verdict_expression)

    @property
    @pulumi.getter(name="verdictExpression")
    def verdict_expression(self) -> 'outputs.MailManagerRuleSetRuleVerdictExpression':
        return pulumi.get(self, "verdict_expression")


@pulumi.output_type
class MailManagerRuleSetRuleCondition5Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dmarcExpression":
            suggest = "dmarc_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetRuleCondition5Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetRuleCondition5Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetRuleCondition5Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dmarc_expression: 'outputs.MailManagerRuleSetRuleDmarcExpression'):
        pulumi.set(__self__, "dmarc_expression", dmarc_expression)

    @property
    @pulumi.getter(name="dmarcExpression")
    def dmarc_expression(self) -> 'outputs.MailManagerRuleSetRuleDmarcExpression':
        return pulumi.get(self, "dmarc_expression")


@pulumi.output_type
class MailManagerRuleSetRuleDmarcExpression(dict):
    def __init__(__self__, *,
                 operator: 'MailManagerRuleSetRuleDmarcOperator',
                 values: Sequence['MailManagerRuleSetRuleDmarcPolicy']):
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleDmarcOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence['MailManagerRuleSetRuleDmarcPolicy']:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerRuleSetRuleIpExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerRuleSetRuleIpToEvaluateProperties',
                 operator: 'MailManagerRuleSetRuleIpOperator',
                 values: Sequence[str]):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerRuleSetRuleIpToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleIpOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerRuleSetRuleIpToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerRuleSetRuleIpEmailAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerRuleSetRuleIpEmailAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerRuleSetRuleNumberExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerRuleSetRuleNumberToEvaluateProperties',
                 operator: 'MailManagerRuleSetRuleNumberOperator',
                 value: float):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerRuleSetRuleNumberToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleNumberOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def value(self) -> float:
        return pulumi.get(self, "value")


@pulumi.output_type
class MailManagerRuleSetRuleNumberToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerRuleSetRuleNumberEmailAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerRuleSetRuleNumberEmailAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerRuleSetRuleStringExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerRuleSetRuleStringToEvaluateProperties',
                 operator: 'MailManagerRuleSetRuleStringOperator',
                 values: Sequence[str]):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerRuleSetRuleStringToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleStringOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerRuleSetRuleStringToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerRuleSetRuleStringEmailAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerRuleSetRuleStringEmailAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerRuleSetRuleVerdictExpression(dict):
    def __init__(__self__, *,
                 evaluate: Any,
                 operator: 'MailManagerRuleSetRuleVerdictOperator',
                 values: Sequence['MailManagerRuleSetRuleVerdict']):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def evaluate(self) -> Any:
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerRuleSetRuleVerdictOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence['MailManagerRuleSetRuleVerdict']:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerRuleSetRuleVerdictToEvaluate0Properties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerRuleSetRuleVerdictAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerRuleSetRuleVerdictAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerRuleSetRuleVerdictToEvaluate1Properties(dict):
    def __init__(__self__, *,
                 analysis: 'outputs.MailManagerRuleSetAnalysis'):
        pulumi.set(__self__, "analysis", analysis)

    @property
    @pulumi.getter
    def analysis(self) -> 'outputs.MailManagerRuleSetAnalysis':
        return pulumi.get(self, "analysis")


@pulumi.output_type
class MailManagerRuleSetS3Action(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "roleArn":
            suggest = "role_arn"
        elif key == "s3Bucket":
            suggest = "s3_bucket"
        elif key == "actionFailurePolicy":
            suggest = "action_failure_policy"
        elif key == "s3Prefix":
            suggest = "s3_prefix"
        elif key == "s3SseKmsKeyId":
            suggest = "s3_sse_kms_key_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetS3Action. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetS3Action.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetS3Action.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 role_arn: str,
                 s3_bucket: str,
                 action_failure_policy: Optional['MailManagerRuleSetActionFailurePolicy'] = None,
                 s3_prefix: Optional[str] = None,
                 s3_sse_kms_key_id: Optional[str] = None):
        pulumi.set(__self__, "role_arn", role_arn)
        pulumi.set(__self__, "s3_bucket", s3_bucket)
        if action_failure_policy is not None:
            pulumi.set(__self__, "action_failure_policy", action_failure_policy)
        if s3_prefix is not None:
            pulumi.set(__self__, "s3_prefix", s3_prefix)
        if s3_sse_kms_key_id is not None:
            pulumi.set(__self__, "s3_sse_kms_key_id", s3_sse_kms_key_id)

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="s3Bucket")
    def s3_bucket(self) -> str:
        return pulumi.get(self, "s3_bucket")

    @property
    @pulumi.getter(name="actionFailurePolicy")
    def action_failure_policy(self) -> Optional['MailManagerRuleSetActionFailurePolicy']:
        return pulumi.get(self, "action_failure_policy")

    @property
    @pulumi.getter(name="s3Prefix")
    def s3_prefix(self) -> Optional[str]:
        return pulumi.get(self, "s3_prefix")

    @property
    @pulumi.getter(name="s3SseKmsKeyId")
    def s3_sse_kms_key_id(self) -> Optional[str]:
        return pulumi.get(self, "s3_sse_kms_key_id")


@pulumi.output_type
class MailManagerRuleSetSendAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "roleArn":
            suggest = "role_arn"
        elif key == "actionFailurePolicy":
            suggest = "action_failure_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerRuleSetSendAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerRuleSetSendAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerRuleSetSendAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 role_arn: str,
                 action_failure_policy: Optional['MailManagerRuleSetActionFailurePolicy'] = None):
        pulumi.set(__self__, "role_arn", role_arn)
        if action_failure_policy is not None:
            pulumi.set(__self__, "action_failure_policy", action_failure_policy)

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="actionFailurePolicy")
    def action_failure_policy(self) -> Optional['MailManagerRuleSetActionFailurePolicy']:
        return pulumi.get(self, "action_failure_policy")


@pulumi.output_type
class MailManagerTrafficPolicyIngressAnalysis(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resultField":
            suggest = "result_field"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerTrafficPolicyIngressAnalysis. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerTrafficPolicyIngressAnalysis.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerTrafficPolicyIngressAnalysis.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 analyzer: str,
                 result_field: str):
        pulumi.set(__self__, "analyzer", analyzer)
        pulumi.set(__self__, "result_field", result_field)

    @property
    @pulumi.getter
    def analyzer(self) -> str:
        return pulumi.get(self, "analyzer")

    @property
    @pulumi.getter(name="resultField")
    def result_field(self) -> str:
        return pulumi.get(self, "result_field")


@pulumi.output_type
class MailManagerTrafficPolicyIngressBooleanExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerTrafficPolicyIngressBooleanToEvaluateProperties',
                 operator: 'MailManagerTrafficPolicyIngressBooleanOperator'):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerTrafficPolicyIngressBooleanToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerTrafficPolicyIngressBooleanOperator':
        return pulumi.get(self, "operator")


@pulumi.output_type
class MailManagerTrafficPolicyIngressBooleanToEvaluateProperties(dict):
    def __init__(__self__, *,
                 analysis: 'outputs.MailManagerTrafficPolicyIngressAnalysis'):
        pulumi.set(__self__, "analysis", analysis)

    @property
    @pulumi.getter
    def analysis(self) -> 'outputs.MailManagerTrafficPolicyIngressAnalysis':
        return pulumi.get(self, "analysis")


@pulumi.output_type
class MailManagerTrafficPolicyIngressIpToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerTrafficPolicyIngressIpv4Attribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerTrafficPolicyIngressIpv4Attribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerTrafficPolicyIngressIpv4Expression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerTrafficPolicyIngressIpToEvaluateProperties',
                 operator: 'MailManagerTrafficPolicyIngressIpOperator',
                 values: Sequence[str]):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerTrafficPolicyIngressIpToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerTrafficPolicyIngressIpOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerTrafficPolicyIngressStringExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerTrafficPolicyIngressStringToEvaluateProperties',
                 operator: 'MailManagerTrafficPolicyIngressStringOperator',
                 values: Sequence[str]):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerTrafficPolicyIngressStringToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerTrafficPolicyIngressStringOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")


@pulumi.output_type
class MailManagerTrafficPolicyIngressStringToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerTrafficPolicyIngressStringEmailAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerTrafficPolicyIngressStringEmailAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerTrafficPolicyIngressTlsProtocolExpression(dict):
    def __init__(__self__, *,
                 evaluate: 'outputs.MailManagerTrafficPolicyIngressTlsProtocolToEvaluateProperties',
                 operator: 'MailManagerTrafficPolicyIngressTlsProtocolOperator',
                 value: 'MailManagerTrafficPolicyIngressTlsProtocolAttribute'):
        pulumi.set(__self__, "evaluate", evaluate)
        pulumi.set(__self__, "operator", operator)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def evaluate(self) -> 'outputs.MailManagerTrafficPolicyIngressTlsProtocolToEvaluateProperties':
        return pulumi.get(self, "evaluate")

    @property
    @pulumi.getter
    def operator(self) -> 'MailManagerTrafficPolicyIngressTlsProtocolOperator':
        return pulumi.get(self, "operator")

    @property
    @pulumi.getter
    def value(self) -> 'MailManagerTrafficPolicyIngressTlsProtocolAttribute':
        return pulumi.get(self, "value")


@pulumi.output_type
class MailManagerTrafficPolicyIngressTlsProtocolToEvaluateProperties(dict):
    def __init__(__self__, *,
                 attribute: 'MailManagerTrafficPolicyIngressTlsAttribute'):
        pulumi.set(__self__, "attribute", attribute)

    @property
    @pulumi.getter
    def attribute(self) -> 'MailManagerTrafficPolicyIngressTlsAttribute':
        return pulumi.get(self, "attribute")


@pulumi.output_type
class MailManagerTrafficPolicyPolicyCondition0Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "stringExpression":
            suggest = "string_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerTrafficPolicyPolicyCondition0Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerTrafficPolicyPolicyCondition0Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerTrafficPolicyPolicyCondition0Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 string_expression: 'outputs.MailManagerTrafficPolicyIngressStringExpression'):
        pulumi.set(__self__, "string_expression", string_expression)

    @property
    @pulumi.getter(name="stringExpression")
    def string_expression(self) -> 'outputs.MailManagerTrafficPolicyIngressStringExpression':
        return pulumi.get(self, "string_expression")


@pulumi.output_type
class MailManagerTrafficPolicyPolicyCondition1Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipExpression":
            suggest = "ip_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerTrafficPolicyPolicyCondition1Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerTrafficPolicyPolicyCondition1Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerTrafficPolicyPolicyCondition1Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_expression: 'outputs.MailManagerTrafficPolicyIngressIpv4Expression'):
        pulumi.set(__self__, "ip_expression", ip_expression)

    @property
    @pulumi.getter(name="ipExpression")
    def ip_expression(self) -> 'outputs.MailManagerTrafficPolicyIngressIpv4Expression':
        return pulumi.get(self, "ip_expression")


@pulumi.output_type
class MailManagerTrafficPolicyPolicyCondition2Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "tlsExpression":
            suggest = "tls_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerTrafficPolicyPolicyCondition2Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerTrafficPolicyPolicyCondition2Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerTrafficPolicyPolicyCondition2Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 tls_expression: 'outputs.MailManagerTrafficPolicyIngressTlsProtocolExpression'):
        pulumi.set(__self__, "tls_expression", tls_expression)

    @property
    @pulumi.getter(name="tlsExpression")
    def tls_expression(self) -> 'outputs.MailManagerTrafficPolicyIngressTlsProtocolExpression':
        return pulumi.get(self, "tls_expression")


@pulumi.output_type
class MailManagerTrafficPolicyPolicyCondition3Properties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "booleanExpression":
            suggest = "boolean_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MailManagerTrafficPolicyPolicyCondition3Properties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MailManagerTrafficPolicyPolicyCondition3Properties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MailManagerTrafficPolicyPolicyCondition3Properties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 boolean_expression: 'outputs.MailManagerTrafficPolicyIngressBooleanExpression'):
        pulumi.set(__self__, "boolean_expression", boolean_expression)

    @property
    @pulumi.getter(name="booleanExpression")
    def boolean_expression(self) -> 'outputs.MailManagerTrafficPolicyIngressBooleanExpression':
        return pulumi.get(self, "boolean_expression")


@pulumi.output_type
class MailManagerTrafficPolicyPolicyStatement(dict):
    def __init__(__self__, *,
                 action: 'MailManagerTrafficPolicyAcceptAction',
                 conditions: Sequence[Any]):
        """
        :param 'MailManagerTrafficPolicyAcceptAction' action: The action that informs a traffic policy resource to either allow or block the email if it matches a condition in the policy statement.
        :param Sequence[Union['MailManagerTrafficPolicyPolicyCondition0Properties', 'MailManagerTrafficPolicyPolicyCondition1Properties', 'MailManagerTrafficPolicyPolicyCondition2Properties', 'MailManagerTrafficPolicyPolicyCondition3Properties']] conditions: The list of conditions to apply to incoming messages for filtering email traffic.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "conditions", conditions)

    @property
    @pulumi.getter
    def action(self) -> 'MailManagerTrafficPolicyAcceptAction':
        """
        The action that informs a traffic policy resource to either allow or block the email if it matches a condition in the policy statement.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def conditions(self) -> Sequence[Any]:
        """
        The list of conditions to apply to incoming messages for filtering email traffic.
        """
        return pulumi.get(self, "conditions")


@pulumi.output_type
class Template(dict):
    """
    The content of the email, composed of a subject line, an HTML part, and a text-only part
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "subjectPart":
            suggest = "subject_part"
        elif key == "htmlPart":
            suggest = "html_part"
        elif key == "templateName":
            suggest = "template_name"
        elif key == "textPart":
            suggest = "text_part"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Template. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Template.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Template.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 subject_part: str,
                 html_part: Optional[str] = None,
                 template_name: Optional[str] = None,
                 text_part: Optional[str] = None):
        """
        The content of the email, composed of a subject line, an HTML part, and a text-only part
        :param str subject_part: The subject line of the email.
        :param str html_part: The HTML body of the email.
        :param str template_name: The name of the template.
        :param str text_part: The email body that is visible to recipients whose email clients do not display HTML content.
        """
        pulumi.set(__self__, "subject_part", subject_part)
        if html_part is not None:
            pulumi.set(__self__, "html_part", html_part)
        if template_name is not None:
            pulumi.set(__self__, "template_name", template_name)
        if text_part is not None:
            pulumi.set(__self__, "text_part", text_part)

    @property
    @pulumi.getter(name="subjectPart")
    def subject_part(self) -> str:
        """
        The subject line of the email.
        """
        return pulumi.get(self, "subject_part")

    @property
    @pulumi.getter(name="htmlPart")
    def html_part(self) -> Optional[str]:
        """
        The HTML body of the email.
        """
        return pulumi.get(self, "html_part")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> Optional[str]:
        """
        The name of the template.
        """
        return pulumi.get(self, "template_name")

    @property
    @pulumi.getter(name="textPart")
    def text_part(self) -> Optional[str]:
        """
        The email body that is visible to recipients whose email clients do not display HTML content.
        """
        return pulumi.get(self, "text_part")


@pulumi.output_type
class VdmAttributesDashboardAttributes(dict):
    """
    Preferences regarding the Dashboard feature.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "engagementMetrics":
            suggest = "engagement_metrics"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VdmAttributesDashboardAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VdmAttributesDashboardAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VdmAttributesDashboardAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 engagement_metrics: Optional[str] = None):
        """
        Preferences regarding the Dashboard feature.
        :param str engagement_metrics: Whether emails sent from this account have engagement tracking enabled.
        """
        if engagement_metrics is not None:
            pulumi.set(__self__, "engagement_metrics", engagement_metrics)

    @property
    @pulumi.getter(name="engagementMetrics")
    def engagement_metrics(self) -> Optional[str]:
        """
        Whether emails sent from this account have engagement tracking enabled.
        """
        return pulumi.get(self, "engagement_metrics")


@pulumi.output_type
class VdmAttributesGuardianAttributes(dict):
    """
    Preferences regarding the Guardian feature.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "optimizedSharedDelivery":
            suggest = "optimized_shared_delivery"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VdmAttributesGuardianAttributes. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VdmAttributesGuardianAttributes.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VdmAttributesGuardianAttributes.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 optimized_shared_delivery: Optional[str] = None):
        """
        Preferences regarding the Guardian feature.
        :param str optimized_shared_delivery: Whether emails sent from this account have optimized delivery algorithm enabled.
        """
        if optimized_shared_delivery is not None:
            pulumi.set(__self__, "optimized_shared_delivery", optimized_shared_delivery)

    @property
    @pulumi.getter(name="optimizedSharedDelivery")
    def optimized_shared_delivery(self) -> Optional[str]:
        """
        Whether emails sent from this account have optimized delivery algorithm enabled.
        """
        return pulumi.get(self, "optimized_shared_delivery")


