# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from ._enums import *

__all__ = [
    'AutomationRuleDateFilterArgs',
    'AutomationRuleDateRangeArgs',
    'AutomationRuleMapFilterArgs',
    'AutomationRuleNoteUpdateArgs',
    'AutomationRuleNumberFilterArgs',
    'AutomationRuleRelatedFindingArgs',
    'AutomationRuleSeverityUpdateArgs',
    'AutomationRuleStringFilterArgs',
    'AutomationRuleWorkflowUpdateArgs',
    'AutomationRulesActionArgs',
    'AutomationRulesFindingFieldsUpdateArgs',
    'AutomationRulesFindingFiltersArgs',
    'ConfigurationPolicyParameterConfigurationArgs',
    'ConfigurationPolicyParameterValueArgs',
    'ConfigurationPolicyPolicyArgs',
    'ConfigurationPolicySecurityControlCustomParameterArgs',
    'ConfigurationPolicySecurityControlsConfigurationArgs',
    'ConfigurationPolicySecurityHubPolicyArgs',
    'InsightAwsSecurityFindingFiltersArgs',
    'InsightBooleanFilterArgs',
    'InsightDateFilterArgs',
    'InsightDateRangeArgs',
    'InsightIpFilterArgs',
    'InsightKeywordFilterArgs',
    'InsightMapFilterArgs',
    'InsightNumberFilterArgs',
    'InsightStringFilterArgs',
    'SecurityControlParameterConfigurationArgs',
    'SecurityControlParameterValueArgs',
    'StandardsControlArgs',
]

@pulumi.input_type
class AutomationRuleDateFilterArgs:
    def __init__(__self__, *,
                 date_range: Optional[pulumi.Input['AutomationRuleDateRangeArgs']] = None,
                 end: Optional[pulumi.Input[str]] = None,
                 start: Optional[pulumi.Input[str]] = None):
        """
        A date filter for querying findings.
        :param pulumi.Input['AutomationRuleDateRangeArgs'] date_range: A date range for the date filter.
        :param pulumi.Input[str] end: A timestamp that provides the end date for the date filter.
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
        :param pulumi.Input[str] start: A timestamp that provides the start date for the date filter.
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
        """
        if date_range is not None:
            pulumi.set(__self__, "date_range", date_range)
        if end is not None:
            pulumi.set(__self__, "end", end)
        if start is not None:
            pulumi.set(__self__, "start", start)

    @property
    @pulumi.getter(name="dateRange")
    def date_range(self) -> Optional[pulumi.Input['AutomationRuleDateRangeArgs']]:
        """
        A date range for the date filter.
        """
        return pulumi.get(self, "date_range")

    @date_range.setter
    def date_range(self, value: Optional[pulumi.Input['AutomationRuleDateRangeArgs']]):
        pulumi.set(self, "date_range", value)

    @property
    @pulumi.getter
    def end(self) -> Optional[pulumi.Input[str]]:
        """
        A timestamp that provides the end date for the date filter.
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
        """
        return pulumi.get(self, "end")

    @end.setter
    def end(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "end", value)

    @property
    @pulumi.getter
    def start(self) -> Optional[pulumi.Input[str]]:
        """
        A timestamp that provides the start date for the date filter.
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
        """
        return pulumi.get(self, "start")

    @start.setter
    def start(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "start", value)


@pulumi.input_type
class AutomationRuleDateRangeArgs:
    def __init__(__self__, *,
                 unit: pulumi.Input['AutomationRuleDateRangeUnit'],
                 value: pulumi.Input[float]):
        """
        A date range for the date filter.
        :param pulumi.Input['AutomationRuleDateRangeUnit'] unit: A date range unit for the date filter.
        :param pulumi.Input[float] value: A date range value for the date filter.
        """
        pulumi.set(__self__, "unit", unit)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def unit(self) -> pulumi.Input['AutomationRuleDateRangeUnit']:
        """
        A date range unit for the date filter.
        """
        return pulumi.get(self, "unit")

    @unit.setter
    def unit(self, value: pulumi.Input['AutomationRuleDateRangeUnit']):
        pulumi.set(self, "unit", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[float]:
        """
        A date range value for the date filter.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[float]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class AutomationRuleMapFilterArgs:
    def __init__(__self__, *,
                 comparison: pulumi.Input['AutomationRuleMapFilterComparison'],
                 key: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        A map filter for filtering ASHlong findings. Each map filter provides the field to check for, the value to check for, and the comparison operator.
        :param pulumi.Input['AutomationRuleMapFilterComparison'] comparison: The condition to apply to the key value when filtering Security Hub findings with a map filter.
                To search for values that have the filter value, use one of the following comparison operators:
                 +  To search for values that include the filter value, use ``CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department CONTAINS Security`` matches findings that include the value ``Security`` for the ``Department`` tag. In the same example, a finding with a value of ``Security team`` for the ``Department`` tag is a match.
                 +  To search for values that exactly match the filter value, use ``EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department EQUALS Security`` matches findings that have the value ``Security`` for the ``Department`` tag.
                 
                 ``CONTAINS`` and ``EQUALS`` filters on the same field are joined by ``OR``. A finding matches if it matches any one of those filters. For example, the filters ``Department CONTAINS Security OR Department CONTAINS Finance`` match a finding that includes either ``Security``, ``Finance``, or both values.
                To search for values that don't have the filter value, use one of the following comparison operators:
                 +  To search for values that exclude the filter value, use ``NOT_CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_CONTAINS Finance`` matches findings that exclude the value ``Finance`` for the ``Department`` tag.
                 +  To search for values other than the filter value, use ``NOT_EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_EQUALS Finance`` matches findings that don’t have the value ``Finance`` for the ``Department`` tag.
                 
                 ``NOT_CONTAINS`` and ``NOT_EQUALS`` filters on the same field are joined by ``AND``. A finding matches only if it matches all of those filters. For example, the filters ``Department NOT_CONTAINS Security AND Department NOT_CONTAINS Finance`` match a finding that excludes both the ``Security`` and ``Finance`` values.
                 ``CONTAINS`` filters can only be used with other ``CONTAINS`` filters. ``NOT_CONTAINS`` filters can only be used with other ``NOT_CONTAINS`` filters.
                You can’t have both a ``CONTAINS`` filter and a ``NOT_CONTAINS`` filter on the same field. Similarly, you can’t have both an ``EQUALS`` filter and a ``NOT_EQUALS`` filter on the same field. Combining filters in this way returns an error. 
                 ``CONTAINS`` and ``NOT_CONTAINS`` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *User Guide*.
        :param pulumi.Input[str] key: The key of the map filter. For example, for ``ResourceTags``, ``Key`` identifies the name of the tag. For ``UserDefinedFields``, ``Key`` is the name of the field.
        :param pulumi.Input[str] value: The value for the key in the map filter. Filter values are case sensitive. For example, one of the values for a tag called ``Department`` might be ``Security``. If you provide ``security`` as the filter value, then there's no match.
        """
        pulumi.set(__self__, "comparison", comparison)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def comparison(self) -> pulumi.Input['AutomationRuleMapFilterComparison']:
        """
        The condition to apply to the key value when filtering Security Hub findings with a map filter.
         To search for values that have the filter value, use one of the following comparison operators:
          +  To search for values that include the filter value, use ``CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department CONTAINS Security`` matches findings that include the value ``Security`` for the ``Department`` tag. In the same example, a finding with a value of ``Security team`` for the ``Department`` tag is a match.
          +  To search for values that exactly match the filter value, use ``EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department EQUALS Security`` matches findings that have the value ``Security`` for the ``Department`` tag.
          
          ``CONTAINS`` and ``EQUALS`` filters on the same field are joined by ``OR``. A finding matches if it matches any one of those filters. For example, the filters ``Department CONTAINS Security OR Department CONTAINS Finance`` match a finding that includes either ``Security``, ``Finance``, or both values.
         To search for values that don't have the filter value, use one of the following comparison operators:
          +  To search for values that exclude the filter value, use ``NOT_CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_CONTAINS Finance`` matches findings that exclude the value ``Finance`` for the ``Department`` tag.
          +  To search for values other than the filter value, use ``NOT_EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_EQUALS Finance`` matches findings that don’t have the value ``Finance`` for the ``Department`` tag.
          
          ``NOT_CONTAINS`` and ``NOT_EQUALS`` filters on the same field are joined by ``AND``. A finding matches only if it matches all of those filters. For example, the filters ``Department NOT_CONTAINS Security AND Department NOT_CONTAINS Finance`` match a finding that excludes both the ``Security`` and ``Finance`` values.
          ``CONTAINS`` filters can only be used with other ``CONTAINS`` filters. ``NOT_CONTAINS`` filters can only be used with other ``NOT_CONTAINS`` filters.
         You can’t have both a ``CONTAINS`` filter and a ``NOT_CONTAINS`` filter on the same field. Similarly, you can’t have both an ``EQUALS`` filter and a ``NOT_EQUALS`` filter on the same field. Combining filters in this way returns an error. 
          ``CONTAINS`` and ``NOT_CONTAINS`` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *User Guide*.
        """
        return pulumi.get(self, "comparison")

    @comparison.setter
    def comparison(self, value: pulumi.Input['AutomationRuleMapFilterComparison']):
        pulumi.set(self, "comparison", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        The key of the map filter. For example, for ``ResourceTags``, ``Key`` identifies the name of the tag. For ``UserDefinedFields``, ``Key`` is the name of the field.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The value for the key in the map filter. Filter values are case sensitive. For example, one of the values for a tag called ``Department`` might be ``Security``. If you provide ``security`` as the filter value, then there's no match.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class AutomationRuleNoteUpdateArgs:
    def __init__(__self__, *,
                 text: pulumi.Input[str],
                 updated_by: pulumi.Input[str]):
        """
        The updated note.
        :param pulumi.Input[str] text: The updated note text.
        :param pulumi.Input[str] updated_by: The principal that updated the note.
        """
        pulumi.set(__self__, "text", text)
        pulumi.set(__self__, "updated_by", updated_by)

    @property
    @pulumi.getter
    def text(self) -> pulumi.Input[str]:
        """
        The updated note text.
        """
        return pulumi.get(self, "text")

    @text.setter
    def text(self, value: pulumi.Input[str]):
        pulumi.set(self, "text", value)

    @property
    @pulumi.getter(name="updatedBy")
    def updated_by(self) -> pulumi.Input[str]:
        """
        The principal that updated the note.
        """
        return pulumi.get(self, "updated_by")

    @updated_by.setter
    def updated_by(self, value: pulumi.Input[str]):
        pulumi.set(self, "updated_by", value)


@pulumi.input_type
class AutomationRuleNumberFilterArgs:
    def __init__(__self__, *,
                 eq: Optional[pulumi.Input[float]] = None,
                 gte: Optional[pulumi.Input[float]] = None,
                 lte: Optional[pulumi.Input[float]] = None):
        """
        A number filter for querying findings.
        :param pulumi.Input[float] eq: The equal-to condition to be applied to a single field when querying for findings.
        :param pulumi.Input[float] gte: The greater-than-equal condition to be applied to a single field when querying for findings.
        :param pulumi.Input[float] lte: The less-than-equal condition to be applied to a single field when querying for findings.
        """
        if eq is not None:
            pulumi.set(__self__, "eq", eq)
        if gte is not None:
            pulumi.set(__self__, "gte", gte)
        if lte is not None:
            pulumi.set(__self__, "lte", lte)

    @property
    @pulumi.getter
    def eq(self) -> Optional[pulumi.Input[float]]:
        """
        The equal-to condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "eq")

    @eq.setter
    def eq(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "eq", value)

    @property
    @pulumi.getter
    def gte(self) -> Optional[pulumi.Input[float]]:
        """
        The greater-than-equal condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "gte")

    @gte.setter
    def gte(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "gte", value)

    @property
    @pulumi.getter
    def lte(self) -> Optional[pulumi.Input[float]]:
        """
        The less-than-equal condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "lte")

    @lte.setter
    def lte(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "lte", value)


@pulumi.input_type
class AutomationRuleRelatedFindingArgs:
    def __init__(__self__, *,
                 id: pulumi.Input[str],
                 product_arn: pulumi.Input[str]):
        """
        Provides details about a list of findings that the current finding relates to.
        :param pulumi.Input[str] id: The product-generated identifier for a related finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[str] product_arn: The Amazon Resource Name (ARN) for the product that generated a related finding.
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "product_arn", product_arn)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[str]:
        """
        The product-generated identifier for a related finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="productArn")
    def product_arn(self) -> pulumi.Input[str]:
        """
        The Amazon Resource Name (ARN) for the product that generated a related finding.
        """
        return pulumi.get(self, "product_arn")

    @product_arn.setter
    def product_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "product_arn", value)


@pulumi.input_type
class AutomationRuleSeverityUpdateArgs:
    def __init__(__self__, *,
                 label: Optional[pulumi.Input['AutomationRuleSeverityUpdateLabel']] = None,
                 normalized: Optional[pulumi.Input[int]] = None,
                 product: Optional[pulumi.Input[float]] = None):
        """
        Updates to the severity information for a finding.
        :param pulumi.Input['AutomationRuleSeverityUpdateLabel'] label: The severity value of the finding. The allowed values are the following.
                 +   ``INFORMATIONAL`` - No issue was found.
                 +   ``LOW`` - The issue does not require action on its own.
                 +   ``MEDIUM`` - The issue must be addressed but not urgently.
                 +   ``HIGH`` - The issue must be addressed as a priority.
                 +   ``CRITICAL`` - The issue must be remediated immediately to avoid it escalating.
        :param pulumi.Input[int] normalized: The normalized severity for the finding. This attribute is to be deprecated in favor of ``Label``.
                If you provide ``Normalized`` and do not provide ``Label``, ``Label`` is set automatically as follows.
                 +  0 - ``INFORMATIONAL`` 
                 +  1–39 - ``LOW`` 
                 +  40–69 - ``MEDIUM`` 
                 +  70–89 - ``HIGH`` 
                 +  90–100 - ``CRITICAL``
        :param pulumi.Input[float] product: The native severity as defined by the AWS service or integrated partner product that generated the finding.
        """
        if label is not None:
            pulumi.set(__self__, "label", label)
        if normalized is not None:
            pulumi.set(__self__, "normalized", normalized)
        if product is not None:
            pulumi.set(__self__, "product", product)

    @property
    @pulumi.getter
    def label(self) -> Optional[pulumi.Input['AutomationRuleSeverityUpdateLabel']]:
        """
        The severity value of the finding. The allowed values are the following.
          +   ``INFORMATIONAL`` - No issue was found.
          +   ``LOW`` - The issue does not require action on its own.
          +   ``MEDIUM`` - The issue must be addressed but not urgently.
          +   ``HIGH`` - The issue must be addressed as a priority.
          +   ``CRITICAL`` - The issue must be remediated immediately to avoid it escalating.
        """
        return pulumi.get(self, "label")

    @label.setter
    def label(self, value: Optional[pulumi.Input['AutomationRuleSeverityUpdateLabel']]):
        pulumi.set(self, "label", value)

    @property
    @pulumi.getter
    def normalized(self) -> Optional[pulumi.Input[int]]:
        """
        The normalized severity for the finding. This attribute is to be deprecated in favor of ``Label``.
         If you provide ``Normalized`` and do not provide ``Label``, ``Label`` is set automatically as follows.
          +  0 - ``INFORMATIONAL`` 
          +  1–39 - ``LOW`` 
          +  40–69 - ``MEDIUM`` 
          +  70–89 - ``HIGH`` 
          +  90–100 - ``CRITICAL``
        """
        return pulumi.get(self, "normalized")

    @normalized.setter
    def normalized(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "normalized", value)

    @property
    @pulumi.getter
    def product(self) -> Optional[pulumi.Input[float]]:
        """
        The native severity as defined by the AWS service or integrated partner product that generated the finding.
        """
        return pulumi.get(self, "product")

    @product.setter
    def product(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "product", value)


@pulumi.input_type
class AutomationRuleStringFilterArgs:
    def __init__(__self__, *,
                 comparison: pulumi.Input['AutomationRuleStringFilterComparison'],
                 value: pulumi.Input[str]):
        """
        A string filter for filtering ASHlong findings.
        :param pulumi.Input['AutomationRuleStringFilterComparison'] comparison: The condition to apply to a string value when filtering Security Hub findings.
                To search for values that have the filter value, use one of the following comparison operators:
                 +  To search for values that include the filter value, use ``CONTAINS``. For example, the filter ``Title CONTAINS CloudFront`` matches findings that have a ``Title`` that includes the string CloudFront.
                 +  To search for values that exactly match the filter value, use ``EQUALS``. For example, the filter ``AwsAccountId EQUALS 123456789012`` only matches findings that have an account ID of ``123456789012``.
                 +  To search for values that start with the filter value, use ``PREFIX``. For example, the filter ``ResourceRegion PREFIX us`` matches findings that have a ``ResourceRegion`` that starts with ``us``. A ``ResourceRegion`` that starts with a different value, such as ``af``, ``ap``, or ``ca``, doesn't match.
                 
                 ``CONTAINS``, ``EQUALS``, and ``PREFIX`` filters on the same field are joined by ``OR``. A finding matches if it matches any one of those filters. For example, the filters ``Title CONTAINS CloudFront OR Title CONTAINS CloudWatch`` match a finding that includes either ``CloudFront``, ``CloudWatch``, or both strings in the title.
                To search for values that don’t have the filter value, use one of the following comparison operators:
                 +  To search for values that exclude the filter value, use ``NOT_CONTAINS``. For example, the filter ``Title NOT_CONTAINS CloudFront`` matches findings that have a ``Title`` that excludes the string CloudFront.
                 +  To search for values other than the filter value, use ``NOT_EQUALS``. For example, the filter ``AwsAccountId NOT_EQUALS 123456789012`` only matches findings that have an account ID other than ``123456789012``.
                 +  To search for values that don't start with the filter value, use ``PREFIX_NOT_EQUALS``. For example, the filter ``ResourceRegion PREFIX_NOT_EQUALS us`` matches findings with a ``ResourceRegion`` that starts with a value other than ``us``.
                 
                 ``NOT_CONTAINS``, ``NOT_EQUALS``, and ``PREFIX_NOT_EQUALS`` filters on the same field are joined by ``AND``. A finding matches only if it matches all of those filters. For example, the filters ``Title NOT_CONTAINS CloudFront AND Title NOT_CONTAINS CloudWatch`` match a finding that excludes both ``CloudFront`` and ``CloudWatch`` in the title.
                You can’t have both a ``CONTAINS`` filter and a ``NOT_CONTAINS`` filter on the same field. Similarly, you can't provide both an ``EQUALS`` filter and a ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filter on the same field. Combining filters in this way returns an error. ``CONTAINS`` filters can only be used with other ``CONTAINS`` filters. ``NOT_CONTAINS`` filters can only be used with other ``NOT_CONTAINS`` filters. 
                You can combine ``PREFIX`` filters with ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filters for the same field. Security Hub first processes the ``PREFIX`` filters, and then the ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filters.
                For example, for the following filters, Security Hub first identifies findings that have resource types that start with either ``AwsIam`` or ``AwsEc2``. It then excludes findings that have a resource type of ``AwsIamPolicy`` and findings that have a resource type of ``AwsEc2NetworkInterface``.
                 +   ``ResourceType PREFIX AwsIam`` 
                 +   ``ResourceType PREFIX AwsEc2`` 
                 +   ``ResourceType NOT_EQUALS AwsIamPolicy`` 
                 +   ``ResourceType NOT_EQUALS AwsEc2NetworkInterface`` 
                 
                 ``CONTAINS`` and ``NOT_CONTAINS`` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *User Guide*.
        :param pulumi.Input[str] value: The string filter value. Filter values are case sensitive. For example, the product name for control-based findings is ``Security Hub``. If you provide ``security hub`` as the filter value, there's no match.
        """
        pulumi.set(__self__, "comparison", comparison)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def comparison(self) -> pulumi.Input['AutomationRuleStringFilterComparison']:
        """
        The condition to apply to a string value when filtering Security Hub findings.
         To search for values that have the filter value, use one of the following comparison operators:
          +  To search for values that include the filter value, use ``CONTAINS``. For example, the filter ``Title CONTAINS CloudFront`` matches findings that have a ``Title`` that includes the string CloudFront.
          +  To search for values that exactly match the filter value, use ``EQUALS``. For example, the filter ``AwsAccountId EQUALS 123456789012`` only matches findings that have an account ID of ``123456789012``.
          +  To search for values that start with the filter value, use ``PREFIX``. For example, the filter ``ResourceRegion PREFIX us`` matches findings that have a ``ResourceRegion`` that starts with ``us``. A ``ResourceRegion`` that starts with a different value, such as ``af``, ``ap``, or ``ca``, doesn't match.
          
          ``CONTAINS``, ``EQUALS``, and ``PREFIX`` filters on the same field are joined by ``OR``. A finding matches if it matches any one of those filters. For example, the filters ``Title CONTAINS CloudFront OR Title CONTAINS CloudWatch`` match a finding that includes either ``CloudFront``, ``CloudWatch``, or both strings in the title.
         To search for values that don’t have the filter value, use one of the following comparison operators:
          +  To search for values that exclude the filter value, use ``NOT_CONTAINS``. For example, the filter ``Title NOT_CONTAINS CloudFront`` matches findings that have a ``Title`` that excludes the string CloudFront.
          +  To search for values other than the filter value, use ``NOT_EQUALS``. For example, the filter ``AwsAccountId NOT_EQUALS 123456789012`` only matches findings that have an account ID other than ``123456789012``.
          +  To search for values that don't start with the filter value, use ``PREFIX_NOT_EQUALS``. For example, the filter ``ResourceRegion PREFIX_NOT_EQUALS us`` matches findings with a ``ResourceRegion`` that starts with a value other than ``us``.
          
          ``NOT_CONTAINS``, ``NOT_EQUALS``, and ``PREFIX_NOT_EQUALS`` filters on the same field are joined by ``AND``. A finding matches only if it matches all of those filters. For example, the filters ``Title NOT_CONTAINS CloudFront AND Title NOT_CONTAINS CloudWatch`` match a finding that excludes both ``CloudFront`` and ``CloudWatch`` in the title.
         You can’t have both a ``CONTAINS`` filter and a ``NOT_CONTAINS`` filter on the same field. Similarly, you can't provide both an ``EQUALS`` filter and a ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filter on the same field. Combining filters in this way returns an error. ``CONTAINS`` filters can only be used with other ``CONTAINS`` filters. ``NOT_CONTAINS`` filters can only be used with other ``NOT_CONTAINS`` filters. 
         You can combine ``PREFIX`` filters with ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filters for the same field. Security Hub first processes the ``PREFIX`` filters, and then the ``NOT_EQUALS`` or ``PREFIX_NOT_EQUALS`` filters.
         For example, for the following filters, Security Hub first identifies findings that have resource types that start with either ``AwsIam`` or ``AwsEc2``. It then excludes findings that have a resource type of ``AwsIamPolicy`` and findings that have a resource type of ``AwsEc2NetworkInterface``.
          +   ``ResourceType PREFIX AwsIam`` 
          +   ``ResourceType PREFIX AwsEc2`` 
          +   ``ResourceType NOT_EQUALS AwsIamPolicy`` 
          +   ``ResourceType NOT_EQUALS AwsEc2NetworkInterface`` 
          
          ``CONTAINS`` and ``NOT_CONTAINS`` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *User Guide*.
        """
        return pulumi.get(self, "comparison")

    @comparison.setter
    def comparison(self, value: pulumi.Input['AutomationRuleStringFilterComparison']):
        pulumi.set(self, "comparison", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The string filter value. Filter values are case sensitive. For example, the product name for control-based findings is ``Security Hub``. If you provide ``security hub`` as the filter value, there's no match.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class AutomationRuleWorkflowUpdateArgs:
    def __init__(__self__, *,
                 status: pulumi.Input['AutomationRuleWorkflowUpdateStatus']):
        """
        Used to update information about the investigation into the finding.
        :param pulumi.Input['AutomationRuleWorkflowUpdateStatus'] status: The status of the investigation into the finding. The workflow status is specific to an individual finding. It does not affect the generation of new findings. For example, setting the workflow status to ``SUPPRESSED`` or ``RESOLVED`` does not prevent a new finding for the same issue.
                The allowed values are the following.
                 +   ``NEW`` - The initial state of a finding, before it is reviewed.
                Security Hub also resets ``WorkFlowStatus`` from ``NOTIFIED`` or ``RESOLVED`` to ``NEW`` in the following cases:
                 +  The record state changes from ``ARCHIVED`` to ``ACTIVE``.
                 +  The compliance status changes from ``PASSED`` to either ``WARNING``, ``FAILED``, or ``NOT_AVAILABLE``.
                 
                 +   ``NOTIFIED`` - Indicates that you notified the resource owner about the security issue. Used when the initial reviewer is not the resource owner, and needs intervention from the resource owner.
                 +   ``RESOLVED`` - The finding was reviewed and remediated and is now considered resolved.
                 +   ``SUPPRESSED`` - Indicates that you reviewed the finding and do not believe that any action is needed. The finding is no longer updated.
        """
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def status(self) -> pulumi.Input['AutomationRuleWorkflowUpdateStatus']:
        """
        The status of the investigation into the finding. The workflow status is specific to an individual finding. It does not affect the generation of new findings. For example, setting the workflow status to ``SUPPRESSED`` or ``RESOLVED`` does not prevent a new finding for the same issue.
         The allowed values are the following.
          +   ``NEW`` - The initial state of a finding, before it is reviewed.
         Security Hub also resets ``WorkFlowStatus`` from ``NOTIFIED`` or ``RESOLVED`` to ``NEW`` in the following cases:
          +  The record state changes from ``ARCHIVED`` to ``ACTIVE``.
          +  The compliance status changes from ``PASSED`` to either ``WARNING``, ``FAILED``, or ``NOT_AVAILABLE``.
          
          +   ``NOTIFIED`` - Indicates that you notified the resource owner about the security issue. Used when the initial reviewer is not the resource owner, and needs intervention from the resource owner.
          +   ``RESOLVED`` - The finding was reviewed and remediated and is now considered resolved.
          +   ``SUPPRESSED`` - Indicates that you reviewed the finding and do not believe that any action is needed. The finding is no longer updated.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: pulumi.Input['AutomationRuleWorkflowUpdateStatus']):
        pulumi.set(self, "status", value)


@pulumi.input_type
class AutomationRulesActionArgs:
    def __init__(__self__, *,
                 finding_fields_update: pulumi.Input['AutomationRulesFindingFieldsUpdateArgs'],
                 type: pulumi.Input['AutomationRulesActionType']):
        """
        One or more actions to update finding fields if a finding matches the defined criteria of the rule.
        :param pulumi.Input['AutomationRulesFindingFieldsUpdateArgs'] finding_fields_update: Specifies that the automation rule action is an update to a finding field.
        :param pulumi.Input['AutomationRulesActionType'] type: Specifies that the rule action should update the ``Types`` finding field. The ``Types`` finding field classifies findings in the format of namespace/category/classifier. For more information, see [Types taxonomy for ASFF](https://docs.aws.amazon.com/securityhub/latest/userguide/securityhub-findings-format-type-taxonomy.html) in the *User Guide*.
        """
        pulumi.set(__self__, "finding_fields_update", finding_fields_update)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="findingFieldsUpdate")
    def finding_fields_update(self) -> pulumi.Input['AutomationRulesFindingFieldsUpdateArgs']:
        """
        Specifies that the automation rule action is an update to a finding field.
        """
        return pulumi.get(self, "finding_fields_update")

    @finding_fields_update.setter
    def finding_fields_update(self, value: pulumi.Input['AutomationRulesFindingFieldsUpdateArgs']):
        pulumi.set(self, "finding_fields_update", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input['AutomationRulesActionType']:
        """
        Specifies that the rule action should update the ``Types`` finding field. The ``Types`` finding field classifies findings in the format of namespace/category/classifier. For more information, see [Types taxonomy for ASFF](https://docs.aws.amazon.com/securityhub/latest/userguide/securityhub-findings-format-type-taxonomy.html) in the *User Guide*.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input['AutomationRulesActionType']):
        pulumi.set(self, "type", value)


@pulumi.input_type
class AutomationRulesFindingFieldsUpdateArgs:
    def __init__(__self__, *,
                 confidence: Optional[pulumi.Input[int]] = None,
                 criticality: Optional[pulumi.Input[int]] = None,
                 note: Optional[pulumi.Input['AutomationRuleNoteUpdateArgs']] = None,
                 related_findings: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleRelatedFindingArgs']]]] = None,
                 severity: Optional[pulumi.Input['AutomationRuleSeverityUpdateArgs']] = None,
                 types: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 user_defined_fields: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 verification_state: Optional[pulumi.Input['AutomationRulesFindingFieldsUpdateVerificationState']] = None,
                 workflow: Optional[pulumi.Input['AutomationRuleWorkflowUpdateArgs']] = None):
        """
        Identifies the finding fields that the automation rule action updates when a finding matches the defined criteria.
        :param pulumi.Input[int] confidence: The rule action updates the ``Confidence`` field of a finding.
        :param pulumi.Input[int] criticality: The rule action updates the ``Criticality`` field of a finding.
        :param pulumi.Input['AutomationRuleNoteUpdateArgs'] note: The rule action will update the ``Note`` field of a finding.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleRelatedFindingArgs']]] related_findings: The rule action will update the ``RelatedFindings`` field of a finding.
        :param pulumi.Input['AutomationRuleSeverityUpdateArgs'] severity: The rule action will update the ``Severity`` field of a finding.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] types: The rule action updates the ``Types`` field of a finding.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] user_defined_fields: The rule action updates the ``UserDefinedFields`` field of a finding.
        :param pulumi.Input['AutomationRulesFindingFieldsUpdateVerificationState'] verification_state: The rule action updates the ``VerificationState`` field of a finding.
        :param pulumi.Input['AutomationRuleWorkflowUpdateArgs'] workflow: The rule action will update the ``Workflow`` field of a finding.
        """
        if confidence is not None:
            pulumi.set(__self__, "confidence", confidence)
        if criticality is not None:
            pulumi.set(__self__, "criticality", criticality)
        if note is not None:
            pulumi.set(__self__, "note", note)
        if related_findings is not None:
            pulumi.set(__self__, "related_findings", related_findings)
        if severity is not None:
            pulumi.set(__self__, "severity", severity)
        if types is not None:
            pulumi.set(__self__, "types", types)
        if user_defined_fields is not None:
            pulumi.set(__self__, "user_defined_fields", user_defined_fields)
        if verification_state is not None:
            pulumi.set(__self__, "verification_state", verification_state)
        if workflow is not None:
            pulumi.set(__self__, "workflow", workflow)

    @property
    @pulumi.getter
    def confidence(self) -> Optional[pulumi.Input[int]]:
        """
        The rule action updates the ``Confidence`` field of a finding.
        """
        return pulumi.get(self, "confidence")

    @confidence.setter
    def confidence(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "confidence", value)

    @property
    @pulumi.getter
    def criticality(self) -> Optional[pulumi.Input[int]]:
        """
        The rule action updates the ``Criticality`` field of a finding.
        """
        return pulumi.get(self, "criticality")

    @criticality.setter
    def criticality(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "criticality", value)

    @property
    @pulumi.getter
    def note(self) -> Optional[pulumi.Input['AutomationRuleNoteUpdateArgs']]:
        """
        The rule action will update the ``Note`` field of a finding.
        """
        return pulumi.get(self, "note")

    @note.setter
    def note(self, value: Optional[pulumi.Input['AutomationRuleNoteUpdateArgs']]):
        pulumi.set(self, "note", value)

    @property
    @pulumi.getter(name="relatedFindings")
    def related_findings(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleRelatedFindingArgs']]]]:
        """
        The rule action will update the ``RelatedFindings`` field of a finding.
        """
        return pulumi.get(self, "related_findings")

    @related_findings.setter
    def related_findings(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleRelatedFindingArgs']]]]):
        pulumi.set(self, "related_findings", value)

    @property
    @pulumi.getter
    def severity(self) -> Optional[pulumi.Input['AutomationRuleSeverityUpdateArgs']]:
        """
        The rule action will update the ``Severity`` field of a finding.
        """
        return pulumi.get(self, "severity")

    @severity.setter
    def severity(self, value: Optional[pulumi.Input['AutomationRuleSeverityUpdateArgs']]):
        pulumi.set(self, "severity", value)

    @property
    @pulumi.getter
    def types(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The rule action updates the ``Types`` field of a finding.
        """
        return pulumi.get(self, "types")

    @types.setter
    def types(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "types", value)

    @property
    @pulumi.getter(name="userDefinedFields")
    def user_defined_fields(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The rule action updates the ``UserDefinedFields`` field of a finding.
        """
        return pulumi.get(self, "user_defined_fields")

    @user_defined_fields.setter
    def user_defined_fields(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "user_defined_fields", value)

    @property
    @pulumi.getter(name="verificationState")
    def verification_state(self) -> Optional[pulumi.Input['AutomationRulesFindingFieldsUpdateVerificationState']]:
        """
        The rule action updates the ``VerificationState`` field of a finding.
        """
        return pulumi.get(self, "verification_state")

    @verification_state.setter
    def verification_state(self, value: Optional[pulumi.Input['AutomationRulesFindingFieldsUpdateVerificationState']]):
        pulumi.set(self, "verification_state", value)

    @property
    @pulumi.getter
    def workflow(self) -> Optional[pulumi.Input['AutomationRuleWorkflowUpdateArgs']]:
        """
        The rule action will update the ``Workflow`` field of a finding.
        """
        return pulumi.get(self, "workflow")

    @workflow.setter
    def workflow(self, value: Optional[pulumi.Input['AutomationRuleWorkflowUpdateArgs']]):
        pulumi.set(self, "workflow", value)


@pulumi.input_type
class AutomationRulesFindingFiltersArgs:
    def __init__(__self__, *,
                 aws_account_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 company_name: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 compliance_associated_standards_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 compliance_security_control_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 compliance_status: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 confidence: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]] = None,
                 created_at: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]] = None,
                 criticality: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]] = None,
                 description: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 first_observed_at: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]] = None,
                 generator_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 last_observed_at: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]] = None,
                 note_text: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 note_updated_at: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]] = None,
                 note_updated_by: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 product_arn: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 product_name: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 record_state: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 related_findings_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 related_findings_product_arn: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 resource_details_other: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]] = None,
                 resource_id: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 resource_partition: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 resource_region: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 resource_tags: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]] = None,
                 resource_type: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 severity_label: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 source_url: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 title: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 type: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 updated_at: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]] = None,
                 user_defined_fields: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]] = None,
                 verification_state: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None,
                 workflow_status: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]] = None):
        """
        The criteria that determine which findings a rule applies to.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] aws_account_id: The AWS-account ID in which a finding was generated.
                 Array Members: Minimum number of 1 item. Maximum number of 100 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] company_name: The name of the company for the product that generated the finding. For control-based findings, the company is AWS. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] compliance_associated_standards_id: The unique identifier of a standard in which a control is enabled. This field consists of the resource portion of the Amazon Resource Name (ARN) returned for a standard in the [DescribeStandards](https://docs.aws.amazon.com/securityhub/1.0/APIReference/API_DescribeStandards.html) API response.
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] compliance_security_control_id: The security control ID for which a finding was generated. Security control IDs are the same across standards.
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] compliance_status: The result of a security check. This field is only used for findings generated from controls. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]] confidence: The likelihood that a finding accurately identifies the behavior or issue that it was intended to identify. ``Confidence`` is scored on a 0–100 basis using a ratio scale. A value of ``0`` means 0 percent confidence, and a value of ``100`` means 100 percent confidence. For example, a data exfiltration detection based on a statistical deviation of network traffic has low confidence because an actual exfiltration hasn't been verified. For more information, see [Confidence](https://docs.aws.amazon.com/securityhub/latest/userguide/asff-top-level-attributes.html#asff-confidence) in the *User Guide*.
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]] created_at: A timestamp that indicates when this finding record was created. 
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
                 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]] criticality: The level of importance that is assigned to the resources that are associated with a finding. ``Criticality`` is scored on a 0–100 basis, using a ratio scale that supports only full integers. A score of ``0`` means that the underlying resources have no criticality, and a score of ``100`` is reserved for the most critical resources. For more information, see [Criticality](https://docs.aws.amazon.com/securityhub/latest/userguide/asff-top-level-attributes.html#asff-criticality) in the *User Guide*.
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] description: A finding's description. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]] first_observed_at: A timestamp that indicates when the potential security issue captured by a finding was first observed by the security findings product. 
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
                 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] generator_id: The identifier for the solution-specific component that generated a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 100 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] id: The product-specific identifier for a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]] last_observed_at: A timestamp that indicates when the potential security issue captured by a finding was most recently observed by the security findings product. 
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
                 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] note_text: The text of a user-defined note that's added to a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]] note_updated_at: The timestamp of when the note was updated.
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
                 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] note_updated_by: The principal that created a note. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] product_arn: The Amazon Resource Name (ARN) for a third-party product that generated a finding in Security Hub. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] product_name: Provides the name of the product that generated the finding. For control-based findings, the product name is Security Hub. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] record_state: Provides the current state of a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] related_findings_id: The product-generated identifier for a related finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] related_findings_product_arn: The ARN for the product that generated a related finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]] resource_details_other: Custom fields and values about the resource that a finding pertains to. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] resource_id: The identifier for the given resource type. For AWS resources that are identified by Amazon Resource Names (ARNs), this is the ARN. For AWS resources that lack ARNs, this is the identifier as defined by the AWS-service that created the resource. For non-AWS resources, this is a unique identifier that is associated with the resource. 
                 Array Members: Minimum number of 1 item. Maximum number of 100 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] resource_partition: The partition in which the resource that the finding pertains to is located. A partition is a group of AWS-Regions. Each AWS-account is scoped to one partition. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] resource_region: The AWS-Region where the resource that a finding pertains to is located. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]] resource_tags: A list of AWS tags associated with a resource at the time the finding was processed. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] resource_type: A finding's title. 
                 Array Members: Minimum number of 1 item. Maximum number of 100 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] severity_label: The severity value of the finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] source_url: Provides a URL that links to a page about the current finding in the finding product. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] title: A finding's title. 
                 Array Members: Minimum number of 1 item. Maximum number of 100 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] type: One or more finding types in the format of namespace/category/classifier that classify a finding. For a list of namespaces, classifiers, and categories, see [Types taxonomy for ASFF](https://docs.aws.amazon.com/securityhub/latest/userguide/securityhub-findings-format-type-taxonomy.html) in the *User Guide*.
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]] updated_at: A timestamp that indicates when the finding record was most recently updated. 
                This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
                 +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
                 +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
                 +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
                 +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
                 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]] user_defined_fields: A list of user-defined name and value string pairs added to a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] verification_state: Provides the veracity of a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        :param pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]] workflow_status: Provides information about the status of the investigation into a finding. 
                 Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        if aws_account_id is not None:
            pulumi.set(__self__, "aws_account_id", aws_account_id)
        if company_name is not None:
            pulumi.set(__self__, "company_name", company_name)
        if compliance_associated_standards_id is not None:
            pulumi.set(__self__, "compliance_associated_standards_id", compliance_associated_standards_id)
        if compliance_security_control_id is not None:
            pulumi.set(__self__, "compliance_security_control_id", compliance_security_control_id)
        if compliance_status is not None:
            pulumi.set(__self__, "compliance_status", compliance_status)
        if confidence is not None:
            pulumi.set(__self__, "confidence", confidence)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if criticality is not None:
            pulumi.set(__self__, "criticality", criticality)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if first_observed_at is not None:
            pulumi.set(__self__, "first_observed_at", first_observed_at)
        if generator_id is not None:
            pulumi.set(__self__, "generator_id", generator_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if last_observed_at is not None:
            pulumi.set(__self__, "last_observed_at", last_observed_at)
        if note_text is not None:
            pulumi.set(__self__, "note_text", note_text)
        if note_updated_at is not None:
            pulumi.set(__self__, "note_updated_at", note_updated_at)
        if note_updated_by is not None:
            pulumi.set(__self__, "note_updated_by", note_updated_by)
        if product_arn is not None:
            pulumi.set(__self__, "product_arn", product_arn)
        if product_name is not None:
            pulumi.set(__self__, "product_name", product_name)
        if record_state is not None:
            pulumi.set(__self__, "record_state", record_state)
        if related_findings_id is not None:
            pulumi.set(__self__, "related_findings_id", related_findings_id)
        if related_findings_product_arn is not None:
            pulumi.set(__self__, "related_findings_product_arn", related_findings_product_arn)
        if resource_details_other is not None:
            pulumi.set(__self__, "resource_details_other", resource_details_other)
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)
        if resource_partition is not None:
            pulumi.set(__self__, "resource_partition", resource_partition)
        if resource_region is not None:
            pulumi.set(__self__, "resource_region", resource_region)
        if resource_tags is not None:
            pulumi.set(__self__, "resource_tags", resource_tags)
        if resource_type is not None:
            pulumi.set(__self__, "resource_type", resource_type)
        if severity_label is not None:
            pulumi.set(__self__, "severity_label", severity_label)
        if source_url is not None:
            pulumi.set(__self__, "source_url", source_url)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if user_defined_fields is not None:
            pulumi.set(__self__, "user_defined_fields", user_defined_fields)
        if verification_state is not None:
            pulumi.set(__self__, "verification_state", verification_state)
        if workflow_status is not None:
            pulumi.set(__self__, "workflow_status", workflow_status)

    @property
    @pulumi.getter(name="awsAccountId")
    def aws_account_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The AWS-account ID in which a finding was generated.
          Array Members: Minimum number of 1 item. Maximum number of 100 items.
        """
        return pulumi.get(self, "aws_account_id")

    @aws_account_id.setter
    def aws_account_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "aws_account_id", value)

    @property
    @pulumi.getter(name="companyName")
    def company_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The name of the company for the product that generated the finding. For control-based findings, the company is AWS. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "company_name")

    @company_name.setter
    def company_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "company_name", value)

    @property
    @pulumi.getter(name="complianceAssociatedStandardsId")
    def compliance_associated_standards_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The unique identifier of a standard in which a control is enabled. This field consists of the resource portion of the Amazon Resource Name (ARN) returned for a standard in the [DescribeStandards](https://docs.aws.amazon.com/securityhub/1.0/APIReference/API_DescribeStandards.html) API response.
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "compliance_associated_standards_id")

    @compliance_associated_standards_id.setter
    def compliance_associated_standards_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "compliance_associated_standards_id", value)

    @property
    @pulumi.getter(name="complianceSecurityControlId")
    def compliance_security_control_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The security control ID for which a finding was generated. Security control IDs are the same across standards.
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "compliance_security_control_id")

    @compliance_security_control_id.setter
    def compliance_security_control_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "compliance_security_control_id", value)

    @property
    @pulumi.getter(name="complianceStatus")
    def compliance_status(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The result of a security check. This field is only used for findings generated from controls. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "compliance_status")

    @compliance_status.setter
    def compliance_status(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "compliance_status", value)

    @property
    @pulumi.getter
    def confidence(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]]:
        """
        The likelihood that a finding accurately identifies the behavior or issue that it was intended to identify. ``Confidence`` is scored on a 0–100 basis using a ratio scale. A value of ``0`` means 0 percent confidence, and a value of ``100`` means 100 percent confidence. For example, a data exfiltration detection based on a statistical deviation of network traffic has low confidence because an actual exfiltration hasn't been verified. For more information, see [Confidence](https://docs.aws.amazon.com/securityhub/latest/userguide/asff-top-level-attributes.html#asff-confidence) in the *User Guide*.
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "confidence")

    @confidence.setter
    def confidence(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]]):
        pulumi.set(self, "confidence", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]:
        """
        A timestamp that indicates when this finding record was created. 
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
          
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def criticality(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]]:
        """
        The level of importance that is assigned to the resources that are associated with a finding. ``Criticality`` is scored on a 0–100 basis, using a ratio scale that supports only full integers. A score of ``0`` means that the underlying resources have no criticality, and a score of ``100`` is reserved for the most critical resources. For more information, see [Criticality](https://docs.aws.amazon.com/securityhub/latest/userguide/asff-top-level-attributes.html#asff-criticality) in the *User Guide*.
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "criticality")

    @criticality.setter
    def criticality(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleNumberFilterArgs']]]]):
        pulumi.set(self, "criticality", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        A finding's description. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="firstObservedAt")
    def first_observed_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]:
        """
        A timestamp that indicates when the potential security issue captured by a finding was first observed by the security findings product. 
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
          
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "first_observed_at")

    @first_observed_at.setter
    def first_observed_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]):
        pulumi.set(self, "first_observed_at", value)

    @property
    @pulumi.getter(name="generatorId")
    def generator_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The identifier for the solution-specific component that generated a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 100 items.
        """
        return pulumi.get(self, "generator_id")

    @generator_id.setter
    def generator_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "generator_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The product-specific identifier for a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="lastObservedAt")
    def last_observed_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]:
        """
        A timestamp that indicates when the potential security issue captured by a finding was most recently observed by the security findings product. 
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
          
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "last_observed_at")

    @last_observed_at.setter
    def last_observed_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]):
        pulumi.set(self, "last_observed_at", value)

    @property
    @pulumi.getter(name="noteText")
    def note_text(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The text of a user-defined note that's added to a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "note_text")

    @note_text.setter
    def note_text(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "note_text", value)

    @property
    @pulumi.getter(name="noteUpdatedAt")
    def note_updated_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]:
        """
        The timestamp of when the note was updated.
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
          
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "note_updated_at")

    @note_updated_at.setter
    def note_updated_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]):
        pulumi.set(self, "note_updated_at", value)

    @property
    @pulumi.getter(name="noteUpdatedBy")
    def note_updated_by(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The principal that created a note. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "note_updated_by")

    @note_updated_by.setter
    def note_updated_by(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "note_updated_by", value)

    @property
    @pulumi.getter(name="productArn")
    def product_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The Amazon Resource Name (ARN) for a third-party product that generated a finding in Security Hub. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "product_arn")

    @product_arn.setter
    def product_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "product_arn", value)

    @property
    @pulumi.getter(name="productName")
    def product_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        Provides the name of the product that generated the finding. For control-based findings, the product name is Security Hub. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "product_name")

    @product_name.setter
    def product_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "product_name", value)

    @property
    @pulumi.getter(name="recordState")
    def record_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        Provides the current state of a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "record_state")

    @record_state.setter
    def record_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "record_state", value)

    @property
    @pulumi.getter(name="relatedFindingsId")
    def related_findings_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The product-generated identifier for a related finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "related_findings_id")

    @related_findings_id.setter
    def related_findings_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "related_findings_id", value)

    @property
    @pulumi.getter(name="relatedFindingsProductArn")
    def related_findings_product_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The ARN for the product that generated a related finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "related_findings_product_arn")

    @related_findings_product_arn.setter
    def related_findings_product_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "related_findings_product_arn", value)

    @property
    @pulumi.getter(name="resourceDetailsOther")
    def resource_details_other(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]:
        """
        Custom fields and values about the resource that a finding pertains to. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "resource_details_other")

    @resource_details_other.setter
    def resource_details_other(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]):
        pulumi.set(self, "resource_details_other", value)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The identifier for the given resource type. For AWS resources that are identified by Amazon Resource Names (ARNs), this is the ARN. For AWS resources that lack ARNs, this is the identifier as defined by the AWS-service that created the resource. For non-AWS resources, this is a unique identifier that is associated with the resource. 
          Array Members: Minimum number of 1 item. Maximum number of 100 items.
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourcePartition")
    def resource_partition(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The partition in which the resource that the finding pertains to is located. A partition is a group of AWS-Regions. Each AWS-account is scoped to one partition. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "resource_partition")

    @resource_partition.setter
    def resource_partition(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "resource_partition", value)

    @property
    @pulumi.getter(name="resourceRegion")
    def resource_region(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The AWS-Region where the resource that a finding pertains to is located. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "resource_region")

    @resource_region.setter
    def resource_region(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "resource_region", value)

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]:
        """
        A list of AWS tags associated with a resource at the time the finding was processed. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "resource_tags")

    @resource_tags.setter
    def resource_tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]):
        pulumi.set(self, "resource_tags", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        A finding's title. 
          Array Members: Minimum number of 1 item. Maximum number of 100 items.
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "resource_type", value)

    @property
    @pulumi.getter(name="severityLabel")
    def severity_label(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        The severity value of the finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "severity_label")

    @severity_label.setter
    def severity_label(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "severity_label", value)

    @property
    @pulumi.getter(name="sourceUrl")
    def source_url(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        Provides a URL that links to a page about the current finding in the finding product. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "source_url")

    @source_url.setter
    def source_url(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "source_url", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        A finding's title. 
          Array Members: Minimum number of 1 item. Maximum number of 100 items.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        One or more finding types in the format of namespace/category/classifier that classify a finding. For a list of namespaces, classifiers, and categories, see [Types taxonomy for ASFF](https://docs.aws.amazon.com/securityhub/latest/userguide/securityhub-findings-format-type-taxonomy.html) in the *User Guide*.
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]:
        """
        A timestamp that indicates when the finding record was most recently updated. 
         This field accepts only the specified formats. Timestamps can end with ``Z`` or ``("+" / "-") time-hour [":" time-minute]``. The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
          +   ``YYYY-MM-DDTHH:MM:SSZ`` (for example, ``2019-01-31T23:00:00Z``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ`` (for example, ``2019-01-31T23:00:00.123456789Z``)
          +   ``YYYY-MM-DDTHH:MM:SS+HH:MM`` (for example, ``2024-01-04T15:25:10+17:59``)
          +   ``YYYY-MM-DDTHH:MM:SS-HHMM`` (for example, ``2024-01-04T15:25:10-1759``)
          +   ``YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM`` (for example, ``2024-01-04T15:25:10.123456789+17:59``)
          
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleDateFilterArgs']]]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="userDefinedFields")
    def user_defined_fields(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]:
        """
        A list of user-defined name and value string pairs added to a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "user_defined_fields")

    @user_defined_fields.setter
    def user_defined_fields(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleMapFilterArgs']]]]):
        pulumi.set(self, "user_defined_fields", value)

    @property
    @pulumi.getter(name="verificationState")
    def verification_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        Provides the veracity of a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "verification_state")

    @verification_state.setter
    def verification_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "verification_state", value)

    @property
    @pulumi.getter(name="workflowStatus")
    def workflow_status(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]:
        """
        Provides information about the status of the investigation into a finding. 
          Array Members: Minimum number of 1 item. Maximum number of 20 items.
        """
        return pulumi.get(self, "workflow_status")

    @workflow_status.setter
    def workflow_status(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AutomationRuleStringFilterArgs']]]]):
        pulumi.set(self, "workflow_status", value)


@pulumi.input_type
class ConfigurationPolicyParameterConfigurationArgs:
    def __init__(__self__, *,
                 value_type: pulumi.Input['ConfigurationPolicyParameterConfigurationValueType'],
                 value: Optional[pulumi.Input['ConfigurationPolicyParameterValueArgs']] = None):
        """
        An object that provides the current value of a security control parameter and identifies whether it has been customized.
        :param pulumi.Input['ConfigurationPolicyParameterConfigurationValueType'] value_type: Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.
        """
        pulumi.set(__self__, "value_type", value_type)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="valueType")
    def value_type(self) -> pulumi.Input['ConfigurationPolicyParameterConfigurationValueType']:
        """
        Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.
        """
        return pulumi.get(self, "value_type")

    @value_type.setter
    def value_type(self, value: pulumi.Input['ConfigurationPolicyParameterConfigurationValueType']):
        pulumi.set(self, "value_type", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input['ConfigurationPolicyParameterValueArgs']]:
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input['ConfigurationPolicyParameterValueArgs']]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class ConfigurationPolicyParameterValueArgs:
    def __init__(__self__, *,
                 boolean: Optional[pulumi.Input[bool]] = None,
                 double: Optional[pulumi.Input[float]] = None,
                 enum: Optional[pulumi.Input[str]] = None,
                 enum_list: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 integer: Optional[pulumi.Input[int]] = None,
                 integer_list: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 string: Optional[pulumi.Input[str]] = None,
                 string_list: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        An object that includes the data type of a security control parameter and its current value.
        :param pulumi.Input[bool] boolean: A control parameter that is a boolean.
        :param pulumi.Input[float] double: A control parameter that is a double.
        :param pulumi.Input[str] enum: A control parameter that is an enum.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enum_list: A control parameter that is a list of enums.
        :param pulumi.Input[int] integer: A control parameter that is an integer.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] integer_list: A control parameter that is a list of integers.
        :param pulumi.Input[str] string: A control parameter that is a string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] string_list: A control parameter that is a list of strings.
        """
        if boolean is not None:
            pulumi.set(__self__, "boolean", boolean)
        if double is not None:
            pulumi.set(__self__, "double", double)
        if enum is not None:
            pulumi.set(__self__, "enum", enum)
        if enum_list is not None:
            pulumi.set(__self__, "enum_list", enum_list)
        if integer is not None:
            pulumi.set(__self__, "integer", integer)
        if integer_list is not None:
            pulumi.set(__self__, "integer_list", integer_list)
        if string is not None:
            pulumi.set(__self__, "string", string)
        if string_list is not None:
            pulumi.set(__self__, "string_list", string_list)

    @property
    @pulumi.getter
    def boolean(self) -> Optional[pulumi.Input[bool]]:
        """
        A control parameter that is a boolean.
        """
        return pulumi.get(self, "boolean")

    @boolean.setter
    def boolean(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "boolean", value)

    @property
    @pulumi.getter
    def double(self) -> Optional[pulumi.Input[float]]:
        """
        A control parameter that is a double.
        """
        return pulumi.get(self, "double")

    @double.setter
    def double(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "double", value)

    @property
    @pulumi.getter
    def enum(self) -> Optional[pulumi.Input[str]]:
        """
        A control parameter that is an enum.
        """
        return pulumi.get(self, "enum")

    @enum.setter
    def enum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enum", value)

    @property
    @pulumi.getter(name="enumList")
    def enum_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A control parameter that is a list of enums.
        """
        return pulumi.get(self, "enum_list")

    @enum_list.setter
    def enum_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enum_list", value)

    @property
    @pulumi.getter
    def integer(self) -> Optional[pulumi.Input[int]]:
        """
        A control parameter that is an integer.
        """
        return pulumi.get(self, "integer")

    @integer.setter
    def integer(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "integer", value)

    @property
    @pulumi.getter(name="integerList")
    def integer_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        A control parameter that is a list of integers.
        """
        return pulumi.get(self, "integer_list")

    @integer_list.setter
    def integer_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "integer_list", value)

    @property
    @pulumi.getter
    def string(self) -> Optional[pulumi.Input[str]]:
        """
        A control parameter that is a string.
        """
        return pulumi.get(self, "string")

    @string.setter
    def string(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "string", value)

    @property
    @pulumi.getter(name="stringList")
    def string_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A control parameter that is a list of strings.
        """
        return pulumi.get(self, "string_list")

    @string_list.setter
    def string_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "string_list", value)


@pulumi.input_type
class ConfigurationPolicyPolicyArgs:
    def __init__(__self__, *,
                 security_hub: Optional[pulumi.Input['ConfigurationPolicySecurityHubPolicyArgs']] = None):
        """
        An object that defines how Security Hub is configured.
        :param pulumi.Input['ConfigurationPolicySecurityHubPolicyArgs'] security_hub: The AWS-service that the configuration policy applies to.
        """
        if security_hub is not None:
            pulumi.set(__self__, "security_hub", security_hub)

    @property
    @pulumi.getter(name="securityHub")
    def security_hub(self) -> Optional[pulumi.Input['ConfigurationPolicySecurityHubPolicyArgs']]:
        """
        The AWS-service that the configuration policy applies to.
        """
        return pulumi.get(self, "security_hub")

    @security_hub.setter
    def security_hub(self, value: Optional[pulumi.Input['ConfigurationPolicySecurityHubPolicyArgs']]):
        pulumi.set(self, "security_hub", value)


@pulumi.input_type
class ConfigurationPolicySecurityControlCustomParameterArgs:
    def __init__(__self__, *,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input['ConfigurationPolicyParameterConfigurationArgs']]]] = None,
                 security_control_id: Optional[pulumi.Input[str]] = None):
        """
        An object of security control and control parameter value that are included in a configuration policy.
        :param pulumi.Input[Mapping[str, pulumi.Input['ConfigurationPolicyParameterConfigurationArgs']]] parameters: An object that specifies parameter values for a control in a configuration policy.
        :param pulumi.Input[str] security_control_id: The ID of the security control.
        """
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if security_control_id is not None:
            pulumi.set(__self__, "security_control_id", security_control_id)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['ConfigurationPolicyParameterConfigurationArgs']]]]:
        """
        An object that specifies parameter values for a control in a configuration policy.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['ConfigurationPolicyParameterConfigurationArgs']]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="securityControlId")
    def security_control_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the security control.
        """
        return pulumi.get(self, "security_control_id")

    @security_control_id.setter
    def security_control_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_control_id", value)


@pulumi.input_type
class ConfigurationPolicySecurityControlsConfigurationArgs:
    def __init__(__self__, *,
                 disabled_security_control_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 enabled_security_control_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_control_custom_parameters: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigurationPolicySecurityControlCustomParameterArgs']]]] = None):
        """
        An object that defines which security controls are enabled in an AWS Security Hub configuration policy.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] disabled_security_control_identifiers: A list of security controls that are disabled in the configuration policy
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_security_control_identifiers: A list of security controls that are enabled in the configuration policy.
        :param pulumi.Input[Sequence[pulumi.Input['ConfigurationPolicySecurityControlCustomParameterArgs']]] security_control_custom_parameters: A list of security controls and control parameter values that are included in a configuration policy.
        """
        if disabled_security_control_identifiers is not None:
            pulumi.set(__self__, "disabled_security_control_identifiers", disabled_security_control_identifiers)
        if enabled_security_control_identifiers is not None:
            pulumi.set(__self__, "enabled_security_control_identifiers", enabled_security_control_identifiers)
        if security_control_custom_parameters is not None:
            pulumi.set(__self__, "security_control_custom_parameters", security_control_custom_parameters)

    @property
    @pulumi.getter(name="disabledSecurityControlIdentifiers")
    def disabled_security_control_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of security controls that are disabled in the configuration policy
        """
        return pulumi.get(self, "disabled_security_control_identifiers")

    @disabled_security_control_identifiers.setter
    def disabled_security_control_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "disabled_security_control_identifiers", value)

    @property
    @pulumi.getter(name="enabledSecurityControlIdentifiers")
    def enabled_security_control_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of security controls that are enabled in the configuration policy.
        """
        return pulumi.get(self, "enabled_security_control_identifiers")

    @enabled_security_control_identifiers.setter
    def enabled_security_control_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enabled_security_control_identifiers", value)

    @property
    @pulumi.getter(name="securityControlCustomParameters")
    def security_control_custom_parameters(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ConfigurationPolicySecurityControlCustomParameterArgs']]]]:
        """
        A list of security controls and control parameter values that are included in a configuration policy.
        """
        return pulumi.get(self, "security_control_custom_parameters")

    @security_control_custom_parameters.setter
    def security_control_custom_parameters(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ConfigurationPolicySecurityControlCustomParameterArgs']]]]):
        pulumi.set(self, "security_control_custom_parameters", value)


@pulumi.input_type
class ConfigurationPolicySecurityHubPolicyArgs:
    def __init__(__self__, *,
                 enabled_standard_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_controls_configuration: Optional[pulumi.Input['ConfigurationPolicySecurityControlsConfigurationArgs']] = None,
                 service_enabled: Optional[pulumi.Input[bool]] = None):
        """
        An object that defines how AWS Security Hub is configured.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_standard_identifiers: A list that defines which security standards are enabled in the configuration policy.
        :param pulumi.Input['ConfigurationPolicySecurityControlsConfigurationArgs'] security_controls_configuration: An object that defines which security controls are enabled in the configuration policy. The enablement status of a control is aligned across all of the enabled standards in an account.
               
               This property is required only if `ServiceEnabled` is set to true in your configuration policy.
        :param pulumi.Input[bool] service_enabled: Indicates whether Security Hub is enabled in the policy.
        """
        if enabled_standard_identifiers is not None:
            pulumi.set(__self__, "enabled_standard_identifiers", enabled_standard_identifiers)
        if security_controls_configuration is not None:
            pulumi.set(__self__, "security_controls_configuration", security_controls_configuration)
        if service_enabled is not None:
            pulumi.set(__self__, "service_enabled", service_enabled)

    @property
    @pulumi.getter(name="enabledStandardIdentifiers")
    def enabled_standard_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list that defines which security standards are enabled in the configuration policy.
        """
        return pulumi.get(self, "enabled_standard_identifiers")

    @enabled_standard_identifiers.setter
    def enabled_standard_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enabled_standard_identifiers", value)

    @property
    @pulumi.getter(name="securityControlsConfiguration")
    def security_controls_configuration(self) -> Optional[pulumi.Input['ConfigurationPolicySecurityControlsConfigurationArgs']]:
        """
        An object that defines which security controls are enabled in the configuration policy. The enablement status of a control is aligned across all of the enabled standards in an account.

        This property is required only if `ServiceEnabled` is set to true in your configuration policy.
        """
        return pulumi.get(self, "security_controls_configuration")

    @security_controls_configuration.setter
    def security_controls_configuration(self, value: Optional[pulumi.Input['ConfigurationPolicySecurityControlsConfigurationArgs']]):
        pulumi.set(self, "security_controls_configuration", value)

    @property
    @pulumi.getter(name="serviceEnabled")
    def service_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Security Hub is enabled in the policy.
        """
        return pulumi.get(self, "service_enabled")

    @service_enabled.setter
    def service_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "service_enabled", value)


@pulumi.input_type
class InsightAwsSecurityFindingFiltersArgs:
    def __init__(__self__, *,
                 aws_account_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 aws_account_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 company_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 compliance_associated_standards_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 compliance_security_control_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 compliance_security_control_parameters_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 compliance_security_control_parameters_value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 compliance_status: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 confidence: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 created_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 criticality: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 description: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 finding_provider_fields_confidence: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 finding_provider_fields_criticality: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 finding_provider_fields_related_findings_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 finding_provider_fields_related_findings_product_arn: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 finding_provider_fields_severity_label: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 finding_provider_fields_severity_original: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 finding_provider_fields_types: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 first_observed_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 generator_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 keyword: Optional[pulumi.Input[Sequence[pulumi.Input['InsightKeywordFilterArgs']]]] = None,
                 last_observed_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 malware_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 malware_path: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 malware_state: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 malware_type: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_destination_domain: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_destination_ip_v4: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 network_destination_ip_v6: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 network_destination_port: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 network_direction: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_protocol: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_source_domain: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_source_ip_v4: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 network_source_ip_v6: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 network_source_mac: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 network_source_port: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 note_text: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 note_updated_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 note_updated_by: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 process_launched_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 process_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 process_parent_pid: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 process_path: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 process_pid: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 process_terminated_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 product_arn: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 product_fields: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]] = None,
                 product_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 recommendation_text: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 record_state: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 region: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 related_findings_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 related_findings_product_arn: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_application_arn: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_application_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_iam_instance_profile_arn: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_image_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_ip_v4_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 resource_aws_ec2_instance_ip_v6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]] = None,
                 resource_aws_ec2_instance_key_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_launched_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 resource_aws_ec2_instance_subnet_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_type: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_ec2_instance_vpc_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_iam_access_key_created_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 resource_aws_iam_access_key_principal_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_iam_access_key_status: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_iam_access_key_user_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_iam_user_user_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_s3_bucket_owner_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_aws_s3_bucket_owner_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_container_image_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_container_image_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_container_launched_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 resource_container_name: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_details_other: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]] = None,
                 resource_id: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_partition: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_region: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 resource_tags: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]] = None,
                 resource_type: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 sample: Optional[pulumi.Input[Sequence[pulumi.Input['InsightBooleanFilterArgs']]]] = None,
                 severity_label: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 severity_normalized: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 severity_product: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]] = None,
                 source_url: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 threat_intel_indicator_category: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 threat_intel_indicator_last_observed_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 threat_intel_indicator_source: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 threat_intel_indicator_source_url: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 threat_intel_indicator_type: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 threat_intel_indicator_value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 title: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 type: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 updated_at: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]] = None,
                 user_defined_fields: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]] = None,
                 verification_state: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 vulnerabilities_exploit_available: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 vulnerabilities_fix_available: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 workflow_state: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None,
                 workflow_status: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]] = None):
        """
        A collection of filters that are applied to all active findings aggregated by AWS Security Hub.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] aws_account_id: The AWS account ID in which a finding is generated.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] aws_account_name: The name of the AWS account in which a finding is generated.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] company_name: The name of the findings provider (company) that owns the solution (product) that generates findings.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] compliance_associated_standards_id: The unique identifier of a standard in which a control is enabled.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] compliance_security_control_id: The unique identifier of a control across standards.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] compliance_security_control_parameters_name: The name of a security control parameter.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] compliance_security_control_parameters_value: The current value of a security control parameter.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] compliance_status: Exclusive to findings that are generated as the result of a check run against a specific rule in a supported standard.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] confidence: A finding's confidence.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] created_at: An ISO8601-formatted timestamp that indicates when the security findings provider captured the potential security issue that a finding captured.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] criticality: The level of importance assigned to the resources associated with the finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] description: A finding's description.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] finding_provider_fields_confidence: The finding provider value for the finding confidence.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] finding_provider_fields_criticality: The finding provider value for the level of importance assigned to the resources associated with the findings.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] finding_provider_fields_related_findings_id: The finding identifier of a related finding that is identified by the finding provider.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] finding_provider_fields_related_findings_product_arn: The ARN of the solution that generated a related finding that is identified by the finding provider.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] finding_provider_fields_severity_label: The finding provider value for the severity label.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] finding_provider_fields_severity_original: The finding provider's original value for the severity.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] finding_provider_fields_types: One or more finding types that the finding provider assigned to the finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] first_observed_at: An ISO8601-formatted timestamp that indicates when the security findings provider first observed the potential security issue that a finding captured.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] generator_id: The identifier for the solution-specific component (a discrete unit of logic) that generated a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] id: The security findings provider-specific identifier for a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightKeywordFilterArgs']]] keyword: A keyword for a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] last_observed_at: An ISO8601-formatted timestamp that indicates when the security findings provider most recently observed the potential security issue that a finding captured.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] malware_name: The name of the malware that was observed.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] malware_path: The filesystem path of the malware that was observed.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] malware_state: The state of the malware that was observed.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] malware_type: The type of the malware that was observed.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] network_destination_domain: The destination domain of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] network_destination_ip_v4: The destination IPv4 address of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] network_destination_ip_v6: The destination IPv6 address of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] network_destination_port: The destination port of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] network_direction: Indicates the direction of network traffic associated with a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] network_protocol: The protocol of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] network_source_domain: The source domain of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] network_source_ip_v4: The source IPv4 address of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] network_source_ip_v6: The source IPv6 address of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] network_source_mac: The source media access control (MAC) address of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] network_source_port: The source port of network-related information about a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] note_text: The text of a note.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] note_updated_at: The timestamp of when the note was updated.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] note_updated_by: The principal that created a note.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] process_launched_at: A timestamp that identifies when the process was launched.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] process_name: The name of the process.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] process_parent_pid: The parent process ID.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] process_path: The path to the process executable.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] process_pid: The process ID.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] process_terminated_at: A timestamp that identifies when the process was terminated.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] product_arn: The ARN generated by Security Hub that uniquely identifies a third-party company (security findings provider) after this provider's product (solution that generates findings) is registered with Security Hub.
        :param pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]] product_fields: A data type where security findings providers can include additional solution-specific details that aren't part of the defined AwsSecurityFinding format.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] product_name: The name of the solution (product) that generates findings.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] recommendation_text: The recommendation of what to do about the issue described in a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] record_state: The updated record state for the finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] region: The Region from which the finding was generated.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] related_findings_id: The solution-generated identifier for a related finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] related_findings_product_arn: The ARN of the solution that generated a related finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_application_arn: The ARN of the application that is related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_application_name: The name of the application that is related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_iam_instance_profile_arn: The IAM profile ARN of the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_image_id: The Amazon Machine Image (AMI) ID of the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] resource_aws_ec2_instance_ip_v4_addresses: The IPv4 addresses associated with the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]] resource_aws_ec2_instance_ip_v6_addresses: The IPv6 addresses associated with the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_key_name: The key name associated with the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] resource_aws_ec2_instance_launched_at: The date and time the instance was launched.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_subnet_id: The identifier of the subnet that the instance was launched in.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_type: The instance type of the instance.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_ec2_instance_vpc_id: The identifier of the VPC that the instance was launched in.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] resource_aws_iam_access_key_created_at: The creation date/time of the IAM access key related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_iam_access_key_principal_name: The name of the principal that is associated with an IAM access key.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_iam_access_key_status: The status of the IAM access key related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_iam_access_key_user_name: The user associated with the IAM access key related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_iam_user_user_name: The name of an IAM user.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_s3_bucket_owner_id: The canonical user ID of the owner of the S3 bucket.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_aws_s3_bucket_owner_name: The display name of the owner of the S3 bucket.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_container_image_id: The identifier of the image related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_container_image_name: The name of the image related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] resource_container_launched_at: A timestamp that identifies when the container was started.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_container_name: The name of the container related to a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]] resource_details_other: The details of a resource that doesn't have a specific subfield for the resource type defined.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_id: The canonical identifier for the given resource type.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_partition: The canonical AWS partition name that the Region is assigned to.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_region: The canonical AWS external Region name where this resource is located.
        :param pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]] resource_tags: A list of AWS tags associated with a resource at the time the finding was processed.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] resource_type: Specifies the type of the resource that details are provided for.
        :param pulumi.Input[Sequence[pulumi.Input['InsightBooleanFilterArgs']]] sample: Indicates whether or not sample findings are included in the filter results.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] severity_label: The label of a finding's severity.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] severity_normalized: The normalized severity of a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]] severity_product: The native severity as defined by the security findings provider's solution that generated the finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] source_url: A URL that links to a page about the current finding in the security findings provider's solution.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] threat_intel_indicator_category: The category of a threat intelligence indicator.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] threat_intel_indicator_last_observed_at: A timestamp that identifies the last observation of a threat intelligence indicator.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] threat_intel_indicator_source: The source of the threat intelligence.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] threat_intel_indicator_source_url: The URL for more details from the source of the threat intelligence.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] threat_intel_indicator_type: The type of a threat intelligence indicator.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] threat_intel_indicator_value: The value of a threat intelligence indicator.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] title: A finding's title.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] type: A finding type in the format of namespace/category/classifier that classifies a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]] updated_at: An ISO8601-formatted timestamp that indicates when the security findings provider last updated the finding record.
        :param pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]] user_defined_fields: A list of name/value string pairs associated with the finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] verification_state: The veracity of a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] vulnerabilities_exploit_available: Indicates whether a software vulnerability in your environment has a known exploit.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] vulnerabilities_fix_available: Indicates whether a vulnerability is fixed in a newer version of the affected software packages.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] workflow_state: The workflow state of a finding.
        :param pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]] workflow_status: The status of the investigation into a finding.
        """
        if aws_account_id is not None:
            pulumi.set(__self__, "aws_account_id", aws_account_id)
        if aws_account_name is not None:
            pulumi.set(__self__, "aws_account_name", aws_account_name)
        if company_name is not None:
            pulumi.set(__self__, "company_name", company_name)
        if compliance_associated_standards_id is not None:
            pulumi.set(__self__, "compliance_associated_standards_id", compliance_associated_standards_id)
        if compliance_security_control_id is not None:
            pulumi.set(__self__, "compliance_security_control_id", compliance_security_control_id)
        if compliance_security_control_parameters_name is not None:
            pulumi.set(__self__, "compliance_security_control_parameters_name", compliance_security_control_parameters_name)
        if compliance_security_control_parameters_value is not None:
            pulumi.set(__self__, "compliance_security_control_parameters_value", compliance_security_control_parameters_value)
        if compliance_status is not None:
            pulumi.set(__self__, "compliance_status", compliance_status)
        if confidence is not None:
            pulumi.set(__self__, "confidence", confidence)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if criticality is not None:
            pulumi.set(__self__, "criticality", criticality)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if finding_provider_fields_confidence is not None:
            pulumi.set(__self__, "finding_provider_fields_confidence", finding_provider_fields_confidence)
        if finding_provider_fields_criticality is not None:
            pulumi.set(__self__, "finding_provider_fields_criticality", finding_provider_fields_criticality)
        if finding_provider_fields_related_findings_id is not None:
            pulumi.set(__self__, "finding_provider_fields_related_findings_id", finding_provider_fields_related_findings_id)
        if finding_provider_fields_related_findings_product_arn is not None:
            pulumi.set(__self__, "finding_provider_fields_related_findings_product_arn", finding_provider_fields_related_findings_product_arn)
        if finding_provider_fields_severity_label is not None:
            pulumi.set(__self__, "finding_provider_fields_severity_label", finding_provider_fields_severity_label)
        if finding_provider_fields_severity_original is not None:
            pulumi.set(__self__, "finding_provider_fields_severity_original", finding_provider_fields_severity_original)
        if finding_provider_fields_types is not None:
            pulumi.set(__self__, "finding_provider_fields_types", finding_provider_fields_types)
        if first_observed_at is not None:
            pulumi.set(__self__, "first_observed_at", first_observed_at)
        if generator_id is not None:
            pulumi.set(__self__, "generator_id", generator_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if keyword is not None:
            pulumi.set(__self__, "keyword", keyword)
        if last_observed_at is not None:
            pulumi.set(__self__, "last_observed_at", last_observed_at)
        if malware_name is not None:
            pulumi.set(__self__, "malware_name", malware_name)
        if malware_path is not None:
            pulumi.set(__self__, "malware_path", malware_path)
        if malware_state is not None:
            pulumi.set(__self__, "malware_state", malware_state)
        if malware_type is not None:
            pulumi.set(__self__, "malware_type", malware_type)
        if network_destination_domain is not None:
            pulumi.set(__self__, "network_destination_domain", network_destination_domain)
        if network_destination_ip_v4 is not None:
            pulumi.set(__self__, "network_destination_ip_v4", network_destination_ip_v4)
        if network_destination_ip_v6 is not None:
            pulumi.set(__self__, "network_destination_ip_v6", network_destination_ip_v6)
        if network_destination_port is not None:
            pulumi.set(__self__, "network_destination_port", network_destination_port)
        if network_direction is not None:
            pulumi.set(__self__, "network_direction", network_direction)
        if network_protocol is not None:
            pulumi.set(__self__, "network_protocol", network_protocol)
        if network_source_domain is not None:
            pulumi.set(__self__, "network_source_domain", network_source_domain)
        if network_source_ip_v4 is not None:
            pulumi.set(__self__, "network_source_ip_v4", network_source_ip_v4)
        if network_source_ip_v6 is not None:
            pulumi.set(__self__, "network_source_ip_v6", network_source_ip_v6)
        if network_source_mac is not None:
            pulumi.set(__self__, "network_source_mac", network_source_mac)
        if network_source_port is not None:
            pulumi.set(__self__, "network_source_port", network_source_port)
        if note_text is not None:
            pulumi.set(__self__, "note_text", note_text)
        if note_updated_at is not None:
            pulumi.set(__self__, "note_updated_at", note_updated_at)
        if note_updated_by is not None:
            pulumi.set(__self__, "note_updated_by", note_updated_by)
        if process_launched_at is not None:
            pulumi.set(__self__, "process_launched_at", process_launched_at)
        if process_name is not None:
            pulumi.set(__self__, "process_name", process_name)
        if process_parent_pid is not None:
            pulumi.set(__self__, "process_parent_pid", process_parent_pid)
        if process_path is not None:
            pulumi.set(__self__, "process_path", process_path)
        if process_pid is not None:
            pulumi.set(__self__, "process_pid", process_pid)
        if process_terminated_at is not None:
            pulumi.set(__self__, "process_terminated_at", process_terminated_at)
        if product_arn is not None:
            pulumi.set(__self__, "product_arn", product_arn)
        if product_fields is not None:
            pulumi.set(__self__, "product_fields", product_fields)
        if product_name is not None:
            pulumi.set(__self__, "product_name", product_name)
        if recommendation_text is not None:
            pulumi.set(__self__, "recommendation_text", recommendation_text)
        if record_state is not None:
            pulumi.set(__self__, "record_state", record_state)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if related_findings_id is not None:
            pulumi.set(__self__, "related_findings_id", related_findings_id)
        if related_findings_product_arn is not None:
            pulumi.set(__self__, "related_findings_product_arn", related_findings_product_arn)
        if resource_application_arn is not None:
            pulumi.set(__self__, "resource_application_arn", resource_application_arn)
        if resource_application_name is not None:
            pulumi.set(__self__, "resource_application_name", resource_application_name)
        if resource_aws_ec2_instance_iam_instance_profile_arn is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_iam_instance_profile_arn", resource_aws_ec2_instance_iam_instance_profile_arn)
        if resource_aws_ec2_instance_image_id is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_image_id", resource_aws_ec2_instance_image_id)
        if resource_aws_ec2_instance_ip_v4_addresses is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_ip_v4_addresses", resource_aws_ec2_instance_ip_v4_addresses)
        if resource_aws_ec2_instance_ip_v6_addresses is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_ip_v6_addresses", resource_aws_ec2_instance_ip_v6_addresses)
        if resource_aws_ec2_instance_key_name is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_key_name", resource_aws_ec2_instance_key_name)
        if resource_aws_ec2_instance_launched_at is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_launched_at", resource_aws_ec2_instance_launched_at)
        if resource_aws_ec2_instance_subnet_id is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_subnet_id", resource_aws_ec2_instance_subnet_id)
        if resource_aws_ec2_instance_type is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_type", resource_aws_ec2_instance_type)
        if resource_aws_ec2_instance_vpc_id is not None:
            pulumi.set(__self__, "resource_aws_ec2_instance_vpc_id", resource_aws_ec2_instance_vpc_id)
        if resource_aws_iam_access_key_created_at is not None:
            pulumi.set(__self__, "resource_aws_iam_access_key_created_at", resource_aws_iam_access_key_created_at)
        if resource_aws_iam_access_key_principal_name is not None:
            pulumi.set(__self__, "resource_aws_iam_access_key_principal_name", resource_aws_iam_access_key_principal_name)
        if resource_aws_iam_access_key_status is not None:
            pulumi.set(__self__, "resource_aws_iam_access_key_status", resource_aws_iam_access_key_status)
        if resource_aws_iam_access_key_user_name is not None:
            pulumi.set(__self__, "resource_aws_iam_access_key_user_name", resource_aws_iam_access_key_user_name)
        if resource_aws_iam_user_user_name is not None:
            pulumi.set(__self__, "resource_aws_iam_user_user_name", resource_aws_iam_user_user_name)
        if resource_aws_s3_bucket_owner_id is not None:
            pulumi.set(__self__, "resource_aws_s3_bucket_owner_id", resource_aws_s3_bucket_owner_id)
        if resource_aws_s3_bucket_owner_name is not None:
            pulumi.set(__self__, "resource_aws_s3_bucket_owner_name", resource_aws_s3_bucket_owner_name)
        if resource_container_image_id is not None:
            pulumi.set(__self__, "resource_container_image_id", resource_container_image_id)
        if resource_container_image_name is not None:
            pulumi.set(__self__, "resource_container_image_name", resource_container_image_name)
        if resource_container_launched_at is not None:
            pulumi.set(__self__, "resource_container_launched_at", resource_container_launched_at)
        if resource_container_name is not None:
            pulumi.set(__self__, "resource_container_name", resource_container_name)
        if resource_details_other is not None:
            pulumi.set(__self__, "resource_details_other", resource_details_other)
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)
        if resource_partition is not None:
            pulumi.set(__self__, "resource_partition", resource_partition)
        if resource_region is not None:
            pulumi.set(__self__, "resource_region", resource_region)
        if resource_tags is not None:
            pulumi.set(__self__, "resource_tags", resource_tags)
        if resource_type is not None:
            pulumi.set(__self__, "resource_type", resource_type)
        if sample is not None:
            pulumi.set(__self__, "sample", sample)
        if severity_label is not None:
            pulumi.set(__self__, "severity_label", severity_label)
        if severity_normalized is not None:
            pulumi.set(__self__, "severity_normalized", severity_normalized)
        if severity_product is not None:
            pulumi.set(__self__, "severity_product", severity_product)
        if source_url is not None:
            pulumi.set(__self__, "source_url", source_url)
        if threat_intel_indicator_category is not None:
            pulumi.set(__self__, "threat_intel_indicator_category", threat_intel_indicator_category)
        if threat_intel_indicator_last_observed_at is not None:
            pulumi.set(__self__, "threat_intel_indicator_last_observed_at", threat_intel_indicator_last_observed_at)
        if threat_intel_indicator_source is not None:
            pulumi.set(__self__, "threat_intel_indicator_source", threat_intel_indicator_source)
        if threat_intel_indicator_source_url is not None:
            pulumi.set(__self__, "threat_intel_indicator_source_url", threat_intel_indicator_source_url)
        if threat_intel_indicator_type is not None:
            pulumi.set(__self__, "threat_intel_indicator_type", threat_intel_indicator_type)
        if threat_intel_indicator_value is not None:
            pulumi.set(__self__, "threat_intel_indicator_value", threat_intel_indicator_value)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if user_defined_fields is not None:
            pulumi.set(__self__, "user_defined_fields", user_defined_fields)
        if verification_state is not None:
            pulumi.set(__self__, "verification_state", verification_state)
        if vulnerabilities_exploit_available is not None:
            pulumi.set(__self__, "vulnerabilities_exploit_available", vulnerabilities_exploit_available)
        if vulnerabilities_fix_available is not None:
            pulumi.set(__self__, "vulnerabilities_fix_available", vulnerabilities_fix_available)
        if workflow_state is not None:
            pulumi.set(__self__, "workflow_state", workflow_state)
        if workflow_status is not None:
            pulumi.set(__self__, "workflow_status", workflow_status)

    @property
    @pulumi.getter(name="awsAccountId")
    def aws_account_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The AWS account ID in which a finding is generated.
        """
        return pulumi.get(self, "aws_account_id")

    @aws_account_id.setter
    def aws_account_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "aws_account_id", value)

    @property
    @pulumi.getter(name="awsAccountName")
    def aws_account_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the AWS account in which a finding is generated.
        """
        return pulumi.get(self, "aws_account_name")

    @aws_account_name.setter
    def aws_account_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "aws_account_name", value)

    @property
    @pulumi.getter(name="companyName")
    def company_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the findings provider (company) that owns the solution (product) that generates findings.
        """
        return pulumi.get(self, "company_name")

    @company_name.setter
    def company_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "company_name", value)

    @property
    @pulumi.getter(name="complianceAssociatedStandardsId")
    def compliance_associated_standards_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The unique identifier of a standard in which a control is enabled.
        """
        return pulumi.get(self, "compliance_associated_standards_id")

    @compliance_associated_standards_id.setter
    def compliance_associated_standards_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "compliance_associated_standards_id", value)

    @property
    @pulumi.getter(name="complianceSecurityControlId")
    def compliance_security_control_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The unique identifier of a control across standards.
        """
        return pulumi.get(self, "compliance_security_control_id")

    @compliance_security_control_id.setter
    def compliance_security_control_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "compliance_security_control_id", value)

    @property
    @pulumi.getter(name="complianceSecurityControlParametersName")
    def compliance_security_control_parameters_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of a security control parameter.
        """
        return pulumi.get(self, "compliance_security_control_parameters_name")

    @compliance_security_control_parameters_name.setter
    def compliance_security_control_parameters_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "compliance_security_control_parameters_name", value)

    @property
    @pulumi.getter(name="complianceSecurityControlParametersValue")
    def compliance_security_control_parameters_value(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The current value of a security control parameter.
        """
        return pulumi.get(self, "compliance_security_control_parameters_value")

    @compliance_security_control_parameters_value.setter
    def compliance_security_control_parameters_value(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "compliance_security_control_parameters_value", value)

    @property
    @pulumi.getter(name="complianceStatus")
    def compliance_status(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        Exclusive to findings that are generated as the result of a check run against a specific rule in a supported standard.
        """
        return pulumi.get(self, "compliance_status")

    @compliance_status.setter
    def compliance_status(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "compliance_status", value)

    @property
    @pulumi.getter
    def confidence(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        A finding's confidence.
        """
        return pulumi.get(self, "confidence")

    @confidence.setter
    def confidence(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "confidence", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        An ISO8601-formatted timestamp that indicates when the security findings provider captured the potential security issue that a finding captured.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def criticality(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The level of importance assigned to the resources associated with the finding.
        """
        return pulumi.get(self, "criticality")

    @criticality.setter
    def criticality(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "criticality", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        A finding's description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="findingProviderFieldsConfidence")
    def finding_provider_fields_confidence(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The finding provider value for the finding confidence.
        """
        return pulumi.get(self, "finding_provider_fields_confidence")

    @finding_provider_fields_confidence.setter
    def finding_provider_fields_confidence(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_confidence", value)

    @property
    @pulumi.getter(name="findingProviderFieldsCriticality")
    def finding_provider_fields_criticality(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The finding provider value for the level of importance assigned to the resources associated with the findings.
        """
        return pulumi.get(self, "finding_provider_fields_criticality")

    @finding_provider_fields_criticality.setter
    def finding_provider_fields_criticality(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_criticality", value)

    @property
    @pulumi.getter(name="findingProviderFieldsRelatedFindingsId")
    def finding_provider_fields_related_findings_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The finding identifier of a related finding that is identified by the finding provider.
        """
        return pulumi.get(self, "finding_provider_fields_related_findings_id")

    @finding_provider_fields_related_findings_id.setter
    def finding_provider_fields_related_findings_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_related_findings_id", value)

    @property
    @pulumi.getter(name="findingProviderFieldsRelatedFindingsProductArn")
    def finding_provider_fields_related_findings_product_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The ARN of the solution that generated a related finding that is identified by the finding provider.
        """
        return pulumi.get(self, "finding_provider_fields_related_findings_product_arn")

    @finding_provider_fields_related_findings_product_arn.setter
    def finding_provider_fields_related_findings_product_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_related_findings_product_arn", value)

    @property
    @pulumi.getter(name="findingProviderFieldsSeverityLabel")
    def finding_provider_fields_severity_label(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The finding provider value for the severity label.
        """
        return pulumi.get(self, "finding_provider_fields_severity_label")

    @finding_provider_fields_severity_label.setter
    def finding_provider_fields_severity_label(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_severity_label", value)

    @property
    @pulumi.getter(name="findingProviderFieldsSeverityOriginal")
    def finding_provider_fields_severity_original(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The finding provider's original value for the severity.
        """
        return pulumi.get(self, "finding_provider_fields_severity_original")

    @finding_provider_fields_severity_original.setter
    def finding_provider_fields_severity_original(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_severity_original", value)

    @property
    @pulumi.getter(name="findingProviderFieldsTypes")
    def finding_provider_fields_types(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        One or more finding types that the finding provider assigned to the finding.
        """
        return pulumi.get(self, "finding_provider_fields_types")

    @finding_provider_fields_types.setter
    def finding_provider_fields_types(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "finding_provider_fields_types", value)

    @property
    @pulumi.getter(name="firstObservedAt")
    def first_observed_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        An ISO8601-formatted timestamp that indicates when the security findings provider first observed the potential security issue that a finding captured.
        """
        return pulumi.get(self, "first_observed_at")

    @first_observed_at.setter
    def first_observed_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "first_observed_at", value)

    @property
    @pulumi.getter(name="generatorId")
    def generator_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The identifier for the solution-specific component (a discrete unit of logic) that generated a finding.
        """
        return pulumi.get(self, "generator_id")

    @generator_id.setter
    def generator_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "generator_id", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The security findings provider-specific identifier for a finding.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def keyword(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightKeywordFilterArgs']]]]:
        """
        A keyword for a finding.
        """
        return pulumi.get(self, "keyword")

    @keyword.setter
    def keyword(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightKeywordFilterArgs']]]]):
        pulumi.set(self, "keyword", value)

    @property
    @pulumi.getter(name="lastObservedAt")
    def last_observed_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        An ISO8601-formatted timestamp that indicates when the security findings provider most recently observed the potential security issue that a finding captured.
        """
        return pulumi.get(self, "last_observed_at")

    @last_observed_at.setter
    def last_observed_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "last_observed_at", value)

    @property
    @pulumi.getter(name="malwareName")
    def malware_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the malware that was observed.
        """
        return pulumi.get(self, "malware_name")

    @malware_name.setter
    def malware_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "malware_name", value)

    @property
    @pulumi.getter(name="malwarePath")
    def malware_path(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The filesystem path of the malware that was observed.
        """
        return pulumi.get(self, "malware_path")

    @malware_path.setter
    def malware_path(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "malware_path", value)

    @property
    @pulumi.getter(name="malwareState")
    def malware_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The state of the malware that was observed.
        """
        return pulumi.get(self, "malware_state")

    @malware_state.setter
    def malware_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "malware_state", value)

    @property
    @pulumi.getter(name="malwareType")
    def malware_type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The type of the malware that was observed.
        """
        return pulumi.get(self, "malware_type")

    @malware_type.setter
    def malware_type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "malware_type", value)

    @property
    @pulumi.getter(name="networkDestinationDomain")
    def network_destination_domain(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The destination domain of network-related information about a finding.
        """
        return pulumi.get(self, "network_destination_domain")

    @network_destination_domain.setter
    def network_destination_domain(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "network_destination_domain", value)

    @property
    @pulumi.getter(name="networkDestinationIpV4")
    def network_destination_ip_v4(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The destination IPv4 address of network-related information about a finding.
        """
        return pulumi.get(self, "network_destination_ip_v4")

    @network_destination_ip_v4.setter
    def network_destination_ip_v4(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "network_destination_ip_v4", value)

    @property
    @pulumi.getter(name="networkDestinationIpV6")
    def network_destination_ip_v6(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The destination IPv6 address of network-related information about a finding.
        """
        return pulumi.get(self, "network_destination_ip_v6")

    @network_destination_ip_v6.setter
    def network_destination_ip_v6(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "network_destination_ip_v6", value)

    @property
    @pulumi.getter(name="networkDestinationPort")
    def network_destination_port(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The destination port of network-related information about a finding.
        """
        return pulumi.get(self, "network_destination_port")

    @network_destination_port.setter
    def network_destination_port(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "network_destination_port", value)

    @property
    @pulumi.getter(name="networkDirection")
    def network_direction(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        Indicates the direction of network traffic associated with a finding.
        """
        return pulumi.get(self, "network_direction")

    @network_direction.setter
    def network_direction(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "network_direction", value)

    @property
    @pulumi.getter(name="networkProtocol")
    def network_protocol(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The protocol of network-related information about a finding.
        """
        return pulumi.get(self, "network_protocol")

    @network_protocol.setter
    def network_protocol(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "network_protocol", value)

    @property
    @pulumi.getter(name="networkSourceDomain")
    def network_source_domain(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The source domain of network-related information about a finding.
        """
        return pulumi.get(self, "network_source_domain")

    @network_source_domain.setter
    def network_source_domain(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "network_source_domain", value)

    @property
    @pulumi.getter(name="networkSourceIpV4")
    def network_source_ip_v4(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The source IPv4 address of network-related information about a finding.
        """
        return pulumi.get(self, "network_source_ip_v4")

    @network_source_ip_v4.setter
    def network_source_ip_v4(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "network_source_ip_v4", value)

    @property
    @pulumi.getter(name="networkSourceIpV6")
    def network_source_ip_v6(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The source IPv6 address of network-related information about a finding.
        """
        return pulumi.get(self, "network_source_ip_v6")

    @network_source_ip_v6.setter
    def network_source_ip_v6(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "network_source_ip_v6", value)

    @property
    @pulumi.getter(name="networkSourceMac")
    def network_source_mac(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The source media access control (MAC) address of network-related information about a finding.
        """
        return pulumi.get(self, "network_source_mac")

    @network_source_mac.setter
    def network_source_mac(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "network_source_mac", value)

    @property
    @pulumi.getter(name="networkSourcePort")
    def network_source_port(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The source port of network-related information about a finding.
        """
        return pulumi.get(self, "network_source_port")

    @network_source_port.setter
    def network_source_port(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "network_source_port", value)

    @property
    @pulumi.getter(name="noteText")
    def note_text(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The text of a note.
        """
        return pulumi.get(self, "note_text")

    @note_text.setter
    def note_text(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "note_text", value)

    @property
    @pulumi.getter(name="noteUpdatedAt")
    def note_updated_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        The timestamp of when the note was updated.
        """
        return pulumi.get(self, "note_updated_at")

    @note_updated_at.setter
    def note_updated_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "note_updated_at", value)

    @property
    @pulumi.getter(name="noteUpdatedBy")
    def note_updated_by(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The principal that created a note.
        """
        return pulumi.get(self, "note_updated_by")

    @note_updated_by.setter
    def note_updated_by(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "note_updated_by", value)

    @property
    @pulumi.getter(name="processLaunchedAt")
    def process_launched_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        A timestamp that identifies when the process was launched.
        """
        return pulumi.get(self, "process_launched_at")

    @process_launched_at.setter
    def process_launched_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "process_launched_at", value)

    @property
    @pulumi.getter(name="processName")
    def process_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the process.
        """
        return pulumi.get(self, "process_name")

    @process_name.setter
    def process_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "process_name", value)

    @property
    @pulumi.getter(name="processParentPid")
    def process_parent_pid(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The parent process ID.
        """
        return pulumi.get(self, "process_parent_pid")

    @process_parent_pid.setter
    def process_parent_pid(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "process_parent_pid", value)

    @property
    @pulumi.getter(name="processPath")
    def process_path(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The path to the process executable.
        """
        return pulumi.get(self, "process_path")

    @process_path.setter
    def process_path(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "process_path", value)

    @property
    @pulumi.getter(name="processPid")
    def process_pid(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The process ID.
        """
        return pulumi.get(self, "process_pid")

    @process_pid.setter
    def process_pid(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "process_pid", value)

    @property
    @pulumi.getter(name="processTerminatedAt")
    def process_terminated_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        A timestamp that identifies when the process was terminated.
        """
        return pulumi.get(self, "process_terminated_at")

    @process_terminated_at.setter
    def process_terminated_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "process_terminated_at", value)

    @property
    @pulumi.getter(name="productArn")
    def product_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The ARN generated by Security Hub that uniquely identifies a third-party company (security findings provider) after this provider's product (solution that generates findings) is registered with Security Hub.
        """
        return pulumi.get(self, "product_arn")

    @product_arn.setter
    def product_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "product_arn", value)

    @property
    @pulumi.getter(name="productFields")
    def product_fields(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]:
        """
        A data type where security findings providers can include additional solution-specific details that aren't part of the defined AwsSecurityFinding format.
        """
        return pulumi.get(self, "product_fields")

    @product_fields.setter
    def product_fields(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]):
        pulumi.set(self, "product_fields", value)

    @property
    @pulumi.getter(name="productName")
    def product_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the solution (product) that generates findings.
        """
        return pulumi.get(self, "product_name")

    @product_name.setter
    def product_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "product_name", value)

    @property
    @pulumi.getter(name="recommendationText")
    def recommendation_text(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The recommendation of what to do about the issue described in a finding.
        """
        return pulumi.get(self, "recommendation_text")

    @recommendation_text.setter
    def recommendation_text(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "recommendation_text", value)

    @property
    @pulumi.getter(name="recordState")
    def record_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The updated record state for the finding.
        """
        return pulumi.get(self, "record_state")

    @record_state.setter
    def record_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "record_state", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The Region from which the finding was generated.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="relatedFindingsId")
    def related_findings_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The solution-generated identifier for a related finding.
        """
        return pulumi.get(self, "related_findings_id")

    @related_findings_id.setter
    def related_findings_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "related_findings_id", value)

    @property
    @pulumi.getter(name="relatedFindingsProductArn")
    def related_findings_product_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The ARN of the solution that generated a related finding.
        """
        return pulumi.get(self, "related_findings_product_arn")

    @related_findings_product_arn.setter
    def related_findings_product_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "related_findings_product_arn", value)

    @property
    @pulumi.getter(name="resourceApplicationArn")
    def resource_application_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The ARN of the application that is related to a finding.
        """
        return pulumi.get(self, "resource_application_arn")

    @resource_application_arn.setter
    def resource_application_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_application_arn", value)

    @property
    @pulumi.getter(name="resourceApplicationName")
    def resource_application_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the application that is related to a finding.
        """
        return pulumi.get(self, "resource_application_name")

    @resource_application_name.setter
    def resource_application_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_application_name", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceIamInstanceProfileArn")
    def resource_aws_ec2_instance_iam_instance_profile_arn(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The IAM profile ARN of the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_iam_instance_profile_arn")

    @resource_aws_ec2_instance_iam_instance_profile_arn.setter
    def resource_aws_ec2_instance_iam_instance_profile_arn(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_iam_instance_profile_arn", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceImageId")
    def resource_aws_ec2_instance_image_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The Amazon Machine Image (AMI) ID of the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_image_id")

    @resource_aws_ec2_instance_image_id.setter
    def resource_aws_ec2_instance_image_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_image_id", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceIpV4Addresses")
    def resource_aws_ec2_instance_ip_v4_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The IPv4 addresses associated with the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_ip_v4_addresses")

    @resource_aws_ec2_instance_ip_v4_addresses.setter
    def resource_aws_ec2_instance_ip_v4_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_ip_v4_addresses", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceIpV6Addresses")
    def resource_aws_ec2_instance_ip_v6_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]:
        """
        The IPv6 addresses associated with the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_ip_v6_addresses")

    @resource_aws_ec2_instance_ip_v6_addresses.setter
    def resource_aws_ec2_instance_ip_v6_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightIpFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_ip_v6_addresses", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceKeyName")
    def resource_aws_ec2_instance_key_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The key name associated with the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_key_name")

    @resource_aws_ec2_instance_key_name.setter
    def resource_aws_ec2_instance_key_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_key_name", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceLaunchedAt")
    def resource_aws_ec2_instance_launched_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        The date and time the instance was launched.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_launched_at")

    @resource_aws_ec2_instance_launched_at.setter
    def resource_aws_ec2_instance_launched_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_launched_at", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceSubnetId")
    def resource_aws_ec2_instance_subnet_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The identifier of the subnet that the instance was launched in.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_subnet_id")

    @resource_aws_ec2_instance_subnet_id.setter
    def resource_aws_ec2_instance_subnet_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_subnet_id", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceType")
    def resource_aws_ec2_instance_type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The instance type of the instance.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_type")

    @resource_aws_ec2_instance_type.setter
    def resource_aws_ec2_instance_type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_type", value)

    @property
    @pulumi.getter(name="resourceAwsEc2InstanceVpcId")
    def resource_aws_ec2_instance_vpc_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The identifier of the VPC that the instance was launched in.
        """
        return pulumi.get(self, "resource_aws_ec2_instance_vpc_id")

    @resource_aws_ec2_instance_vpc_id.setter
    def resource_aws_ec2_instance_vpc_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_ec2_instance_vpc_id", value)

    @property
    @pulumi.getter(name="resourceAwsIamAccessKeyCreatedAt")
    def resource_aws_iam_access_key_created_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        The creation date/time of the IAM access key related to a finding.
        """
        return pulumi.get(self, "resource_aws_iam_access_key_created_at")

    @resource_aws_iam_access_key_created_at.setter
    def resource_aws_iam_access_key_created_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "resource_aws_iam_access_key_created_at", value)

    @property
    @pulumi.getter(name="resourceAwsIamAccessKeyPrincipalName")
    def resource_aws_iam_access_key_principal_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the principal that is associated with an IAM access key.
        """
        return pulumi.get(self, "resource_aws_iam_access_key_principal_name")

    @resource_aws_iam_access_key_principal_name.setter
    def resource_aws_iam_access_key_principal_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_iam_access_key_principal_name", value)

    @property
    @pulumi.getter(name="resourceAwsIamAccessKeyStatus")
    def resource_aws_iam_access_key_status(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The status of the IAM access key related to a finding.
        """
        return pulumi.get(self, "resource_aws_iam_access_key_status")

    @resource_aws_iam_access_key_status.setter
    def resource_aws_iam_access_key_status(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_iam_access_key_status", value)

    @property
    @pulumi.getter(name="resourceAwsIamAccessKeyUserName")
    def resource_aws_iam_access_key_user_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The user associated with the IAM access key related to a finding.
        """
        return pulumi.get(self, "resource_aws_iam_access_key_user_name")

    @resource_aws_iam_access_key_user_name.setter
    def resource_aws_iam_access_key_user_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_iam_access_key_user_name", value)

    @property
    @pulumi.getter(name="resourceAwsIamUserUserName")
    def resource_aws_iam_user_user_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of an IAM user.
        """
        return pulumi.get(self, "resource_aws_iam_user_user_name")

    @resource_aws_iam_user_user_name.setter
    def resource_aws_iam_user_user_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_iam_user_user_name", value)

    @property
    @pulumi.getter(name="resourceAwsS3BucketOwnerId")
    def resource_aws_s3_bucket_owner_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The canonical user ID of the owner of the S3 bucket.
        """
        return pulumi.get(self, "resource_aws_s3_bucket_owner_id")

    @resource_aws_s3_bucket_owner_id.setter
    def resource_aws_s3_bucket_owner_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_s3_bucket_owner_id", value)

    @property
    @pulumi.getter(name="resourceAwsS3BucketOwnerName")
    def resource_aws_s3_bucket_owner_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The display name of the owner of the S3 bucket.
        """
        return pulumi.get(self, "resource_aws_s3_bucket_owner_name")

    @resource_aws_s3_bucket_owner_name.setter
    def resource_aws_s3_bucket_owner_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_aws_s3_bucket_owner_name", value)

    @property
    @pulumi.getter(name="resourceContainerImageId")
    def resource_container_image_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The identifier of the image related to a finding.
        """
        return pulumi.get(self, "resource_container_image_id")

    @resource_container_image_id.setter
    def resource_container_image_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_container_image_id", value)

    @property
    @pulumi.getter(name="resourceContainerImageName")
    def resource_container_image_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the image related to a finding.
        """
        return pulumi.get(self, "resource_container_image_name")

    @resource_container_image_name.setter
    def resource_container_image_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_container_image_name", value)

    @property
    @pulumi.getter(name="resourceContainerLaunchedAt")
    def resource_container_launched_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        A timestamp that identifies when the container was started.
        """
        return pulumi.get(self, "resource_container_launched_at")

    @resource_container_launched_at.setter
    def resource_container_launched_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "resource_container_launched_at", value)

    @property
    @pulumi.getter(name="resourceContainerName")
    def resource_container_name(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The name of the container related to a finding.
        """
        return pulumi.get(self, "resource_container_name")

    @resource_container_name.setter
    def resource_container_name(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_container_name", value)

    @property
    @pulumi.getter(name="resourceDetailsOther")
    def resource_details_other(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]:
        """
        The details of a resource that doesn't have a specific subfield for the resource type defined.
        """
        return pulumi.get(self, "resource_details_other")

    @resource_details_other.setter
    def resource_details_other(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]):
        pulumi.set(self, "resource_details_other", value)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The canonical identifier for the given resource type.
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourcePartition")
    def resource_partition(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The canonical AWS partition name that the Region is assigned to.
        """
        return pulumi.get(self, "resource_partition")

    @resource_partition.setter
    def resource_partition(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_partition", value)

    @property
    @pulumi.getter(name="resourceRegion")
    def resource_region(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The canonical AWS external Region name where this resource is located.
        """
        return pulumi.get(self, "resource_region")

    @resource_region.setter
    def resource_region(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_region", value)

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]:
        """
        A list of AWS tags associated with a resource at the time the finding was processed.
        """
        return pulumi.get(self, "resource_tags")

    @resource_tags.setter
    def resource_tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]):
        pulumi.set(self, "resource_tags", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        Specifies the type of the resource that details are provided for.
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "resource_type", value)

    @property
    @pulumi.getter
    def sample(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightBooleanFilterArgs']]]]:
        """
        Indicates whether or not sample findings are included in the filter results.
        """
        return pulumi.get(self, "sample")

    @sample.setter
    def sample(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightBooleanFilterArgs']]]]):
        pulumi.set(self, "sample", value)

    @property
    @pulumi.getter(name="severityLabel")
    def severity_label(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The label of a finding's severity.
        """
        return pulumi.get(self, "severity_label")

    @severity_label.setter
    def severity_label(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "severity_label", value)

    @property
    @pulumi.getter(name="severityNormalized")
    def severity_normalized(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The normalized severity of a finding.
        """
        return pulumi.get(self, "severity_normalized")

    @severity_normalized.setter
    def severity_normalized(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "severity_normalized", value)

    @property
    @pulumi.getter(name="severityProduct")
    def severity_product(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]:
        """
        The native severity as defined by the security findings provider's solution that generated the finding.
        """
        return pulumi.get(self, "severity_product")

    @severity_product.setter
    def severity_product(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightNumberFilterArgs']]]]):
        pulumi.set(self, "severity_product", value)

    @property
    @pulumi.getter(name="sourceUrl")
    def source_url(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        A URL that links to a page about the current finding in the security findings provider's solution.
        """
        return pulumi.get(self, "source_url")

    @source_url.setter
    def source_url(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "source_url", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorCategory")
    def threat_intel_indicator_category(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The category of a threat intelligence indicator.
        """
        return pulumi.get(self, "threat_intel_indicator_category")

    @threat_intel_indicator_category.setter
    def threat_intel_indicator_category(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_category", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorLastObservedAt")
    def threat_intel_indicator_last_observed_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        A timestamp that identifies the last observation of a threat intelligence indicator.
        """
        return pulumi.get(self, "threat_intel_indicator_last_observed_at")

    @threat_intel_indicator_last_observed_at.setter
    def threat_intel_indicator_last_observed_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_last_observed_at", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorSource")
    def threat_intel_indicator_source(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The source of the threat intelligence.
        """
        return pulumi.get(self, "threat_intel_indicator_source")

    @threat_intel_indicator_source.setter
    def threat_intel_indicator_source(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_source", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorSourceUrl")
    def threat_intel_indicator_source_url(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The URL for more details from the source of the threat intelligence.
        """
        return pulumi.get(self, "threat_intel_indicator_source_url")

    @threat_intel_indicator_source_url.setter
    def threat_intel_indicator_source_url(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_source_url", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorType")
    def threat_intel_indicator_type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The type of a threat intelligence indicator.
        """
        return pulumi.get(self, "threat_intel_indicator_type")

    @threat_intel_indicator_type.setter
    def threat_intel_indicator_type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_type", value)

    @property
    @pulumi.getter(name="threatIntelIndicatorValue")
    def threat_intel_indicator_value(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The value of a threat intelligence indicator.
        """
        return pulumi.get(self, "threat_intel_indicator_value")

    @threat_intel_indicator_value.setter
    def threat_intel_indicator_value(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "threat_intel_indicator_value", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        A finding's title.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        A finding type in the format of namespace/category/classifier that classifies a finding.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]:
        """
        An ISO8601-formatted timestamp that indicates when the security findings provider last updated the finding record.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightDateFilterArgs']]]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="userDefinedFields")
    def user_defined_fields(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]:
        """
        A list of name/value string pairs associated with the finding.
        """
        return pulumi.get(self, "user_defined_fields")

    @user_defined_fields.setter
    def user_defined_fields(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightMapFilterArgs']]]]):
        pulumi.set(self, "user_defined_fields", value)

    @property
    @pulumi.getter(name="verificationState")
    def verification_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The veracity of a finding.
        """
        return pulumi.get(self, "verification_state")

    @verification_state.setter
    def verification_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "verification_state", value)

    @property
    @pulumi.getter(name="vulnerabilitiesExploitAvailable")
    def vulnerabilities_exploit_available(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        Indicates whether a software vulnerability in your environment has a known exploit.
        """
        return pulumi.get(self, "vulnerabilities_exploit_available")

    @vulnerabilities_exploit_available.setter
    def vulnerabilities_exploit_available(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "vulnerabilities_exploit_available", value)

    @property
    @pulumi.getter(name="vulnerabilitiesFixAvailable")
    def vulnerabilities_fix_available(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        Indicates whether a vulnerability is fixed in a newer version of the affected software packages.
        """
        return pulumi.get(self, "vulnerabilities_fix_available")

    @vulnerabilities_fix_available.setter
    def vulnerabilities_fix_available(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "vulnerabilities_fix_available", value)

    @property
    @pulumi.getter(name="workflowState")
    def workflow_state(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The workflow state of a finding.
        """
        return pulumi.get(self, "workflow_state")

    @workflow_state.setter
    def workflow_state(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "workflow_state", value)

    @property
    @pulumi.getter(name="workflowStatus")
    def workflow_status(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]:
        """
        The status of the investigation into a finding.
        """
        return pulumi.get(self, "workflow_status")

    @workflow_status.setter
    def workflow_status(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InsightStringFilterArgs']]]]):
        pulumi.set(self, "workflow_status", value)


@pulumi.input_type
class InsightBooleanFilterArgs:
    def __init__(__self__, *,
                 value: pulumi.Input[bool]):
        """
        Boolean filter for querying findings.
        :param pulumi.Input[bool] value: The value of the boolean.
        """
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[bool]:
        """
        The value of the boolean.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[bool]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class InsightDateFilterArgs:
    def __init__(__self__, *,
                 date_range: Optional[pulumi.Input['InsightDateRangeArgs']] = None,
                 end: Optional[pulumi.Input[str]] = None,
                 start: Optional[pulumi.Input[str]] = None):
        """
        A date filter for querying findings.
        :param pulumi.Input['InsightDateRangeArgs'] date_range: A date range for the date filter.
        :param pulumi.Input[str] end: A timestamp that provides the end date for the date filter.
               
               This field accepts only the specified formats. Timestamps can end with `Z` or `("+" / "-") time-hour [":" time-minute]` . The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
               
               - `YYYY-MM-DDTHH:MM:SSZ` (for example, `2019-01-31T23:00:00Z` )
               - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ` (for example, `2019-01-31T23:00:00.123456789Z` )
               - `YYYY-MM-DDTHH:MM:SS+HH:MM` (for example, `2024-01-04T15:25:10+17:59` )
               - `YYYY-MM-DDTHH:MM:SS-HHMM` (for example, `2024-01-04T15:25:10-1759` )
               - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM` (for example, `2024-01-04T15:25:10.123456789+17:59` )
        :param pulumi.Input[str] start: A timestamp that provides the start date for the date filter.
               
               This field accepts only the specified formats. Timestamps can end with `Z` or `("+" / "-") time-hour [":" time-minute]` . The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:
               
               - `YYYY-MM-DDTHH:MM:SSZ` (for example, `2019-01-31T23:00:00Z` )
               - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ` (for example, `2019-01-31T23:00:00.123456789Z` )
               - `YYYY-MM-DDTHH:MM:SS+HH:MM` (for example, `2024-01-04T15:25:10+17:59` )
               - `YYYY-MM-DDTHH:MM:SS-HHMM` (for example, `2024-01-04T15:25:10-1759` )
               - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM` (for example, `2024-01-04T15:25:10.123456789+17:59` )
        """
        if date_range is not None:
            pulumi.set(__self__, "date_range", date_range)
        if end is not None:
            pulumi.set(__self__, "end", end)
        if start is not None:
            pulumi.set(__self__, "start", start)

    @property
    @pulumi.getter(name="dateRange")
    def date_range(self) -> Optional[pulumi.Input['InsightDateRangeArgs']]:
        """
        A date range for the date filter.
        """
        return pulumi.get(self, "date_range")

    @date_range.setter
    def date_range(self, value: Optional[pulumi.Input['InsightDateRangeArgs']]):
        pulumi.set(self, "date_range", value)

    @property
    @pulumi.getter
    def end(self) -> Optional[pulumi.Input[str]]:
        """
        A timestamp that provides the end date for the date filter.

        This field accepts only the specified formats. Timestamps can end with `Z` or `("+" / "-") time-hour [":" time-minute]` . The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:

        - `YYYY-MM-DDTHH:MM:SSZ` (for example, `2019-01-31T23:00:00Z` )
        - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ` (for example, `2019-01-31T23:00:00.123456789Z` )
        - `YYYY-MM-DDTHH:MM:SS+HH:MM` (for example, `2024-01-04T15:25:10+17:59` )
        - `YYYY-MM-DDTHH:MM:SS-HHMM` (for example, `2024-01-04T15:25:10-1759` )
        - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM` (for example, `2024-01-04T15:25:10.123456789+17:59` )
        """
        return pulumi.get(self, "end")

    @end.setter
    def end(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "end", value)

    @property
    @pulumi.getter
    def start(self) -> Optional[pulumi.Input[str]]:
        """
        A timestamp that provides the start date for the date filter.

        This field accepts only the specified formats. Timestamps can end with `Z` or `("+" / "-") time-hour [":" time-minute]` . The time-secfrac after seconds is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats with examples:

        - `YYYY-MM-DDTHH:MM:SSZ` (for example, `2019-01-31T23:00:00Z` )
        - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ` (for example, `2019-01-31T23:00:00.123456789Z` )
        - `YYYY-MM-DDTHH:MM:SS+HH:MM` (for example, `2024-01-04T15:25:10+17:59` )
        - `YYYY-MM-DDTHH:MM:SS-HHMM` (for example, `2024-01-04T15:25:10-1759` )
        - `YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM` (for example, `2024-01-04T15:25:10.123456789+17:59` )
        """
        return pulumi.get(self, "start")

    @start.setter
    def start(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "start", value)


@pulumi.input_type
class InsightDateRangeArgs:
    def __init__(__self__, *,
                 unit: pulumi.Input['InsightDateRangeUnit'],
                 value: pulumi.Input[float]):
        """
        A date range for the date filter.
        :param pulumi.Input['InsightDateRangeUnit'] unit: A date range unit for the date filter.
        :param pulumi.Input[float] value: A date range value for the date filter.
        """
        pulumi.set(__self__, "unit", unit)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def unit(self) -> pulumi.Input['InsightDateRangeUnit']:
        """
        A date range unit for the date filter.
        """
        return pulumi.get(self, "unit")

    @unit.setter
    def unit(self, value: pulumi.Input['InsightDateRangeUnit']):
        pulumi.set(self, "unit", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[float]:
        """
        A date range value for the date filter.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[float]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class InsightIpFilterArgs:
    def __init__(__self__, *,
                 cidr: pulumi.Input[str]):
        """
        The IP filter for querying findings.
        :param pulumi.Input[str] cidr: A finding's CIDR value.
        """
        pulumi.set(__self__, "cidr", cidr)

    @property
    @pulumi.getter
    def cidr(self) -> pulumi.Input[str]:
        """
        A finding's CIDR value.
        """
        return pulumi.get(self, "cidr")

    @cidr.setter
    def cidr(self, value: pulumi.Input[str]):
        pulumi.set(self, "cidr", value)


@pulumi.input_type
class InsightKeywordFilterArgs:
    def __init__(__self__, *,
                 value: pulumi.Input[str]):
        """
        A keyword filter for querying findings.
        :param pulumi.Input[str] value: A value for the keyword.
        """
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        A value for the keyword.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class InsightMapFilterArgs:
    def __init__(__self__, *,
                 comparison: pulumi.Input['InsightMapFilterComparison'],
                 key: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        A map filter for filtering AWS Security Hub findings.
        :param pulumi.Input['InsightMapFilterComparison'] comparison: The condition to apply to the key value when filtering Security Hub findings with a map filter.
        :param pulumi.Input[str] key: The key of the map filter. For example, for `ResourceTags` , `Key` identifies the name of the tag. For `UserDefinedFields` , `Key` is the name of the field.
        :param pulumi.Input[str] value: The value for the key in the map filter. Filter values are case sensitive. For example, one of the values for a tag called `Department` might be `Security` . If you provide `security` as the filter value, then there's no match.
        """
        pulumi.set(__self__, "comparison", comparison)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def comparison(self) -> pulumi.Input['InsightMapFilterComparison']:
        """
        The condition to apply to the key value when filtering Security Hub findings with a map filter.
        """
        return pulumi.get(self, "comparison")

    @comparison.setter
    def comparison(self, value: pulumi.Input['InsightMapFilterComparison']):
        pulumi.set(self, "comparison", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        The key of the map filter. For example, for `ResourceTags` , `Key` identifies the name of the tag. For `UserDefinedFields` , `Key` is the name of the field.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The value for the key in the map filter. Filter values are case sensitive. For example, one of the values for a tag called `Department` might be `Security` . If you provide `security` as the filter value, then there's no match.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class InsightNumberFilterArgs:
    def __init__(__self__, *,
                 eq: Optional[pulumi.Input[float]] = None,
                 gte: Optional[pulumi.Input[float]] = None,
                 lte: Optional[pulumi.Input[float]] = None):
        """
        A number filter for querying findings.
        :param pulumi.Input[float] eq: The equal-to condition to be applied to a single field when querying for findings.
        :param pulumi.Input[float] gte: The greater-than-equal condition to be applied to a single field when querying for findings.
        :param pulumi.Input[float] lte: The less-than-equal condition to be applied to a single field when querying for findings.
        """
        if eq is not None:
            pulumi.set(__self__, "eq", eq)
        if gte is not None:
            pulumi.set(__self__, "gte", gte)
        if lte is not None:
            pulumi.set(__self__, "lte", lte)

    @property
    @pulumi.getter
    def eq(self) -> Optional[pulumi.Input[float]]:
        """
        The equal-to condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "eq")

    @eq.setter
    def eq(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "eq", value)

    @property
    @pulumi.getter
    def gte(self) -> Optional[pulumi.Input[float]]:
        """
        The greater-than-equal condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "gte")

    @gte.setter
    def gte(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "gte", value)

    @property
    @pulumi.getter
    def lte(self) -> Optional[pulumi.Input[float]]:
        """
        The less-than-equal condition to be applied to a single field when querying for findings.
        """
        return pulumi.get(self, "lte")

    @lte.setter
    def lte(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "lte", value)


@pulumi.input_type
class InsightStringFilterArgs:
    def __init__(__self__, *,
                 comparison: pulumi.Input['InsightStringFilterComparison'],
                 value: pulumi.Input[str]):
        """
        A string filter for filtering AWS Security Hub findings.
        :param pulumi.Input['InsightStringFilterComparison'] comparison: The condition to apply to a string value when filtering Security Hub findings.
               
               To search for values that have the filter value, use one of the following comparison operators:
               
               - To search for values that include the filter value, use `CONTAINS` . For example, the filter `Title CONTAINS CloudFront` matches findings that have a `Title` that includes the string CloudFront.
               - To search for values that exactly match the filter value, use `EQUALS` . For example, the filter `AwsAccountId EQUALS 123456789012` only matches findings that have an account ID of `123456789012` .
               - To search for values that start with the filter value, use `PREFIX` . For example, the filter `ResourceRegion PREFIX us` matches findings that have a `ResourceRegion` that starts with `us` . A `ResourceRegion` that starts with a different value, such as `af` , `ap` , or `ca` , doesn't match.
               
               `CONTAINS` , `EQUALS` , and `PREFIX` filters on the same field are joined by `OR` . A finding matches if it matches any one of those filters. For example, the filters `Title CONTAINS CloudFront OR Title CONTAINS CloudWatch` match a finding that includes either `CloudFront` , `CloudWatch` , or both strings in the title.
               
               To search for values that don’t have the filter value, use one of the following comparison operators:
               
               - To search for values that exclude the filter value, use `NOT_CONTAINS` . For example, the filter `Title NOT_CONTAINS CloudFront` matches findings that have a `Title` that excludes the string CloudFront.
               - To search for values other than the filter value, use `NOT_EQUALS` . For example, the filter `AwsAccountId NOT_EQUALS 123456789012` only matches findings that have an account ID other than `123456789012` .
               - To search for values that don't start with the filter value, use `PREFIX_NOT_EQUALS` . For example, the filter `ResourceRegion PREFIX_NOT_EQUALS us` matches findings with a `ResourceRegion` that starts with a value other than `us` .
               
               `NOT_CONTAINS` , `NOT_EQUALS` , and `PREFIX_NOT_EQUALS` filters on the same field are joined by `AND` . A finding matches only if it matches all of those filters. For example, the filters `Title NOT_CONTAINS CloudFront AND Title NOT_CONTAINS CloudWatch` match a finding that excludes both `CloudFront` and `CloudWatch` in the title.
               
               You can’t have both a `CONTAINS` filter and a `NOT_CONTAINS` filter on the same field. Similarly, you can't provide both an `EQUALS` filter and a `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filter on the same field. Combining filters in this way returns an error. `CONTAINS` filters can only be used with other `CONTAINS` filters. `NOT_CONTAINS` filters can only be used with other `NOT_CONTAINS` filters.
               
               You can combine `PREFIX` filters with `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filters for the same field. Security Hub first processes the `PREFIX` filters, and then the `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filters.
               
               For example, for the following filters, Security Hub first identifies findings that have resource types that start with either `AwsIam` or `AwsEc2` . It then excludes findings that have a resource type of `AwsIamPolicy` and findings that have a resource type of `AwsEc2NetworkInterface` .
               
               - `ResourceType PREFIX AwsIam`
               - `ResourceType PREFIX AwsEc2`
               - `ResourceType NOT_EQUALS AwsIamPolicy`
               - `ResourceType NOT_EQUALS AwsEc2NetworkInterface`
               
               `CONTAINS` and `NOT_CONTAINS` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *AWS Security Hub User Guide* .
        :param pulumi.Input[str] value: The string filter value. Filter values are case sensitive. For example, the product name for control-based findings is `Security Hub` . If you provide `security hub` as the filter value, there's no match.
        """
        pulumi.set(__self__, "comparison", comparison)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def comparison(self) -> pulumi.Input['InsightStringFilterComparison']:
        """
        The condition to apply to a string value when filtering Security Hub findings.

        To search for values that have the filter value, use one of the following comparison operators:

        - To search for values that include the filter value, use `CONTAINS` . For example, the filter `Title CONTAINS CloudFront` matches findings that have a `Title` that includes the string CloudFront.
        - To search for values that exactly match the filter value, use `EQUALS` . For example, the filter `AwsAccountId EQUALS 123456789012` only matches findings that have an account ID of `123456789012` .
        - To search for values that start with the filter value, use `PREFIX` . For example, the filter `ResourceRegion PREFIX us` matches findings that have a `ResourceRegion` that starts with `us` . A `ResourceRegion` that starts with a different value, such as `af` , `ap` , or `ca` , doesn't match.

        `CONTAINS` , `EQUALS` , and `PREFIX` filters on the same field are joined by `OR` . A finding matches if it matches any one of those filters. For example, the filters `Title CONTAINS CloudFront OR Title CONTAINS CloudWatch` match a finding that includes either `CloudFront` , `CloudWatch` , or both strings in the title.

        To search for values that don’t have the filter value, use one of the following comparison operators:

        - To search for values that exclude the filter value, use `NOT_CONTAINS` . For example, the filter `Title NOT_CONTAINS CloudFront` matches findings that have a `Title` that excludes the string CloudFront.
        - To search for values other than the filter value, use `NOT_EQUALS` . For example, the filter `AwsAccountId NOT_EQUALS 123456789012` only matches findings that have an account ID other than `123456789012` .
        - To search for values that don't start with the filter value, use `PREFIX_NOT_EQUALS` . For example, the filter `ResourceRegion PREFIX_NOT_EQUALS us` matches findings with a `ResourceRegion` that starts with a value other than `us` .

        `NOT_CONTAINS` , `NOT_EQUALS` , and `PREFIX_NOT_EQUALS` filters on the same field are joined by `AND` . A finding matches only if it matches all of those filters. For example, the filters `Title NOT_CONTAINS CloudFront AND Title NOT_CONTAINS CloudWatch` match a finding that excludes both `CloudFront` and `CloudWatch` in the title.

        You can’t have both a `CONTAINS` filter and a `NOT_CONTAINS` filter on the same field. Similarly, you can't provide both an `EQUALS` filter and a `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filter on the same field. Combining filters in this way returns an error. `CONTAINS` filters can only be used with other `CONTAINS` filters. `NOT_CONTAINS` filters can only be used with other `NOT_CONTAINS` filters.

        You can combine `PREFIX` filters with `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filters for the same field. Security Hub first processes the `PREFIX` filters, and then the `NOT_EQUALS` or `PREFIX_NOT_EQUALS` filters.

        For example, for the following filters, Security Hub first identifies findings that have resource types that start with either `AwsIam` or `AwsEc2` . It then excludes findings that have a resource type of `AwsIamPolicy` and findings that have a resource type of `AwsEc2NetworkInterface` .

        - `ResourceType PREFIX AwsIam`
        - `ResourceType PREFIX AwsEc2`
        - `ResourceType NOT_EQUALS AwsIamPolicy`
        - `ResourceType NOT_EQUALS AwsEc2NetworkInterface`

        `CONTAINS` and `NOT_CONTAINS` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *AWS Security Hub User Guide* .
        """
        return pulumi.get(self, "comparison")

    @comparison.setter
    def comparison(self, value: pulumi.Input['InsightStringFilterComparison']):
        pulumi.set(self, "comparison", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The string filter value. Filter values are case sensitive. For example, the product name for control-based findings is `Security Hub` . If you provide `security hub` as the filter value, there's no match.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class SecurityControlParameterConfigurationArgs:
    def __init__(__self__, *,
                 value_type: pulumi.Input['SecurityControlParameterConfigurationValueType'],
                 value: Optional[pulumi.Input['SecurityControlParameterValueArgs']] = None):
        """
        :param pulumi.Input['SecurityControlParameterConfigurationValueType'] value_type: Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.
               
               When `ValueType` is set equal to `DEFAULT` , the default behavior can be a specific Security Hub default value, or the default behavior can be to ignore a specific parameter. When `ValueType` is set equal to `DEFAULT` , Security Hub ignores user-provided input for the `Value` field.
               
               When `ValueType` is set equal to `CUSTOM` , the `Value` field can't be empty.
        :param pulumi.Input['SecurityControlParameterValueArgs'] value: The current value of a control parameter.
        """
        pulumi.set(__self__, "value_type", value_type)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="valueType")
    def value_type(self) -> pulumi.Input['SecurityControlParameterConfigurationValueType']:
        """
        Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.

        When `ValueType` is set equal to `DEFAULT` , the default behavior can be a specific Security Hub default value, or the default behavior can be to ignore a specific parameter. When `ValueType` is set equal to `DEFAULT` , Security Hub ignores user-provided input for the `Value` field.

        When `ValueType` is set equal to `CUSTOM` , the `Value` field can't be empty.
        """
        return pulumi.get(self, "value_type")

    @value_type.setter
    def value_type(self, value: pulumi.Input['SecurityControlParameterConfigurationValueType']):
        pulumi.set(self, "value_type", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input['SecurityControlParameterValueArgs']]:
        """
        The current value of a control parameter.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input['SecurityControlParameterValueArgs']]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class SecurityControlParameterValueArgs:
    def __init__(__self__, *,
                 boolean: Optional[pulumi.Input[bool]] = None,
                 double: Optional[pulumi.Input[float]] = None,
                 enum: Optional[pulumi.Input[str]] = None,
                 enum_list: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 integer: Optional[pulumi.Input[int]] = None,
                 integer_list: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 string: Optional[pulumi.Input[str]] = None,
                 string_list: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[bool] boolean: A control parameter that is a boolean.
        :param pulumi.Input[float] double: A control parameter that is a double.
        :param pulumi.Input[str] enum: A control parameter that is a enum.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enum_list: A control parameter that is a list of enums.
        :param pulumi.Input[int] integer: A control parameter that is a integer.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] integer_list: A control parameter that is a list of integers.
        :param pulumi.Input[str] string: A control parameter that is a string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] string_list: A control parameter that is a list of strings.
        """
        if boolean is not None:
            pulumi.set(__self__, "boolean", boolean)
        if double is not None:
            pulumi.set(__self__, "double", double)
        if enum is not None:
            pulumi.set(__self__, "enum", enum)
        if enum_list is not None:
            pulumi.set(__self__, "enum_list", enum_list)
        if integer is not None:
            pulumi.set(__self__, "integer", integer)
        if integer_list is not None:
            pulumi.set(__self__, "integer_list", integer_list)
        if string is not None:
            pulumi.set(__self__, "string", string)
        if string_list is not None:
            pulumi.set(__self__, "string_list", string_list)

    @property
    @pulumi.getter
    def boolean(self) -> Optional[pulumi.Input[bool]]:
        """
        A control parameter that is a boolean.
        """
        return pulumi.get(self, "boolean")

    @boolean.setter
    def boolean(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "boolean", value)

    @property
    @pulumi.getter
    def double(self) -> Optional[pulumi.Input[float]]:
        """
        A control parameter that is a double.
        """
        return pulumi.get(self, "double")

    @double.setter
    def double(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "double", value)

    @property
    @pulumi.getter
    def enum(self) -> Optional[pulumi.Input[str]]:
        """
        A control parameter that is a enum.
        """
        return pulumi.get(self, "enum")

    @enum.setter
    def enum(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enum", value)

    @property
    @pulumi.getter(name="enumList")
    def enum_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A control parameter that is a list of enums.
        """
        return pulumi.get(self, "enum_list")

    @enum_list.setter
    def enum_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enum_list", value)

    @property
    @pulumi.getter
    def integer(self) -> Optional[pulumi.Input[int]]:
        """
        A control parameter that is a integer.
        """
        return pulumi.get(self, "integer")

    @integer.setter
    def integer(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "integer", value)

    @property
    @pulumi.getter(name="integerList")
    def integer_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        A control parameter that is a list of integers.
        """
        return pulumi.get(self, "integer_list")

    @integer_list.setter
    def integer_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "integer_list", value)

    @property
    @pulumi.getter
    def string(self) -> Optional[pulumi.Input[str]]:
        """
        A control parameter that is a string.
        """
        return pulumi.get(self, "string")

    @string.setter
    def string(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "string", value)

    @property
    @pulumi.getter(name="stringList")
    def string_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A control parameter that is a list of strings.
        """
        return pulumi.get(self, "string_list")

    @string_list.setter
    def string_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "string_list", value)


@pulumi.input_type
class StandardsControlArgs:
    def __init__(__self__, *,
                 standards_control_arn: pulumi.Input[str],
                 reason: Optional[pulumi.Input[str]] = None):
        """
        Provides details about an individual security control. For a list of ASH controls, see [controls reference](https://docs.aws.amazon.com/securityhub/latest/userguide/securityhub-controls-reference.html) in the *User Guide*.
        :param pulumi.Input[str] standards_control_arn: The Amazon Resource Name (ARN) of the control.
        :param pulumi.Input[str] reason: A user-defined reason for changing a control's enablement status in a specified standard. If you are disabling a control, then this property is required.
        """
        pulumi.set(__self__, "standards_control_arn", standards_control_arn)
        if reason is not None:
            pulumi.set(__self__, "reason", reason)

    @property
    @pulumi.getter(name="standardsControlArn")
    def standards_control_arn(self) -> pulumi.Input[str]:
        """
        The Amazon Resource Name (ARN) of the control.
        """
        return pulumi.get(self, "standards_control_arn")

    @standards_control_arn.setter
    def standards_control_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "standards_control_arn", value)

    @property
    @pulumi.getter
    def reason(self) -> Optional[pulumi.Input[str]]:
        """
        A user-defined reason for changing a control's enablement status in a specified standard. If you are disabling a control, then this property is required.
        """
        return pulumi.get(self, "reason")

    @reason.setter
    def reason(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reason", value)


